#!BPY

"""
Name: 'PROCAD_26'
Blender: 2.48
Group: 'Mesh'
Tip: 'Tools for CAD 2D-3D in Blender'

__author__ = "Paolo Provenda (JAPY)"
__version__ = "2.6 del 27/12/08"

__bpydoc__=""\
Uso: Leggere il manuale allegato in formato PDF.
	 	
	 Buon divertimento!   
"""


# $Id: PROCAD_26.py,v 2.6 del 27/12/2008 14:20:00 Paolo Provenda (JAPY) $
#
# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****
# --------------------------------------------------------------------------

import Blender
from Blender import *
from Blender import Mesh,Window,Draw,Mathutils,Text
from Blender.Mathutils import *
from Blender.BGL import *
from Blender.Draw import *
import math
from math import *
import os
import sys

dirsrc=os.path.join(Blender.Get("scriptsdir"),"dati_procad")
sys.path.append(dirsrc)

indice=0
indicet=""
modosnap=1
mvista=[[0.0,0.0,0.0,0.0],[0.0,0.0,0.0,0.0],[0.0,0.0,0.0,0.0],[0.0,0.0,0.0],[0.0,0.0,0.0],[0.0,0.0,0.0]]
limita=Create(0.001)
frazione=Create(10)
misuradata=Create(1.0)
tog=Create(0)
tog2=Create(0)
tog3=Create(1)
tog4=Create(1)
togx=Create(1)
togy=Create(1)
togz=Create(1)
togsnap=Create(0)
togrem=Create(1)
togscegli=Create(1)
togmuovi=Create(0)
diaz=[0.0,0.0]
mcur=[]
msel=[]
vsel=[]
matr=[0.0,0.0,0.0,0.0]
cc=[0.0,0.0,0.0]
rico=[1,0.0,1.0,1.0,1,0.0,0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,360.0,0.0,0.0,0.0,0.0,0.0,0.0,360.0,0.0,0.0,0,0,0.0]
nrico=[0.0,0.0,0.0,0.0,0.0,0.0,1,0.0,0.0,0.0,0.0,0.0,0.0,0,0.0,0.0,0.0,1.0,1.0,1.0,0,0,3]
nr=[0.0,0.0,0.0,0.0,0.0,0.0,1]
riquote=[0.2,0.3,1.0,0.2,1,0,1.0,0,1.0,"g",""]
memtog=[1,1,0,0,0]
trovato=[]
ob=[]

cur=[0.,0.,0.]
for i in range(0,20):
	mcur.append(cur)
	msel.append(cur)
	vsel.append(0)

Blender.c1=mcur[0]
Blender.c2=mcur[1]
Blender.s1=msel[0]
Blender.s2=msel[1]

EVENT_NIENTE = 1
EVENT_DISEGNA = 2
EVENT_ESCI = 3
EVENT_PERPENDICOLARE = 4
EVENT_PUNTO = 6
EVENT_CREAPOLARE = 7
EVENT_FIGURE = 8
EVENT_SXYZ = 10
EVENT_P1 = 12
EVENT_UNDCUR = 14
EVENT_REDCUR = 15
EVENT_SPIGOLO = 16
EVENT_SPIGOLO2 = 17
EVENT_S = 18
EVENT_PUNTO2 = 21
EVENT_PARALLELA = 22
EVENT_DISTANZA = 23
EVENT_PROIETTA = 24
EVENT_DISEGNA2 = 25
EVENT_INFO = 26
EVENT_SNAP1 = 27
EVENT_ALLINEA = 5
EVENT_ARROTO = 28
EVENT_CREACERCHIO3P = 29
EVENT_CONGIUNGI = 30
EVENT_QUOTE = 31
EVENT_ELLISSI = 32
EVENT_PUNTOCOO = 33
EVENT_TAGLIA = 34
EVENT_MURO = 35
EVENT_ORTO = 36
EVENT_DIMENSION = 37
EVENT_MODOSNAP = 38
EVENT_TOFACE = 39
EVENT_TOLINE = 40
EVENT_MEMOVISTA = 41
EVENT_LOAD = 42
EVENT_EXT = 43
EVENT_ALLINEA2 = 44
EVENT_COMANDI = 45

try:
	IMG = Blender.Image.Load(os.path.join(dirsrc,"logo26.jpg"))
except:
	IMG=""
	print"Error: loading Image of the GUI, the functions are not activated."
		
# carica script disegno mcur e msel
sce=Blender.Scene.GetCurrent()
NAMESCRIPT='visualsnap2.py'
if NAMESCRIPT not in [t.name for t in Blender.Text.Get()]:
	Blender.Text.Load(os.path.join(dirsrc,NAMESCRIPT))
if sce.getScriptLinks('Redraw')== None : 
	sce.addScriptLink(NAMESCRIPT,'Redraw')
elif 'visualsnap2.py' not in sce.getScriptLinks('Redraw'): 
	sce.addScriptLink(NAMESCRIPT,'Redraw')
NAMESCRIPT2='visualsnap3.py'
if NAMESCRIPT2 not in [t.name for t in Blender.Text.Get()]:
	Blender.Text.Load(os.path.join(dirsrc,NAMESCRIPT2))
if sce.getScriptLinks('Redraw')== None : 
	sce.addScriptLink(NAMESCRIPT2,'Redraw')
elif 'visualsnap3.py' not in sce.getScriptLinks('Redraw'): 
	sce.addScriptLink(NAMESCRIPT2,'Redraw')


def draw():
	global tog,tog2,tog3,tog4,quotaz,togmuovi,togsnap
	global togx,togy,togz,cur,mcur,indice,togscegli,msel,vsel,rico,nrico,nr,riquote
	global togrem,indicet,limita,memtog,modosnap,frazione,misuradata
	global EVENT_NIENTE,EVENT_DISEGNA,EVENT_ESCI
	
	if IMG:
		Image(IMG,0,0)
		glRasterPos2d(80,57)
		Text (indicet)
	else:
		glClearColor(.4,.5,.68,1)
		glClear(GL_COLOR_BUFFER_BIT)
		glRasterPos2d(10,55)
		Text("PROCAD 2.6 by Provenda Paolo (JAPY) 2008")
		glRasterPos2d(10,13)
		Text ("Azione: "+indicet)

	PushButton("MIS",EVENT_DISEGNA2,507,32,26,13,"Measurements of objects or parts of them")
	PushButton("POL",EVENT_CREAPOLARE,227,32,26,13,"Line from the point selected to the coord. creates one polar relative")
	PushButton("PER",EVENT_PERPENDICOLARE,451,32,26,13,"Create a perpendicular line to the segment M1-M2 passing through the 3D cursor")
	PushButton("MCUR",EVENT_P1,563,32,26,13,"Acquire cursor point 1")
	PushButton("MSEL",EVENT_S,535,32,26,13,"Acquire selected point")
	PushButton("UCUR",EVENT_UNDCUR,591,32,26,13,"Restore the cursor in the previous point (20 undo)")
	PushButton("RCUR",EVENT_REDCUR,619,32,26,13,"Restore the cursor in the following point (20 redo)")
	PushButton("SNAP",EVENT_MODOSNAP,563,80,26,13,"Type of interaction: 3D snap cursor with wheel mouse")
	PushButton("MVI",EVENT_MEMOVISTA,591,80,26,13,"Save the present view")
	PushButton("DIM",EVENT_DIMENSION,675,80,26,13,"Set the size of the selections in edit mode")
	PushButton("FACCIA",EVENT_TOFACE,703,80,26,13,"Project the selection over a face (C/S = Create/Grab vertexes)")
	PushButton("LINEA",EVENT_TOLINE,731,80,26,13,"Project the selection over a line (C/S = Create/Grab vertexes)")
	PushButton("ALLINEA",EVENT_ALLINEA2,759,80,26,13,"Align the selection on a direction line")
	PushButton("CON",EVENT_CONGIUNGI,339,32,26,13,"Join a line to another (C/S = Create/Grab vertex)")
	PushButton("SPI",EVENT_SPIGOLO,367,32,26,13,"Create a 90 degree edge between 2 selected vertexes (</> = Inside/Outside)")
	PushButton("TAG",EVENT_TAGLIA,395,32,26,13,"Cut the selected lines")
	PushButton("SPE",EVENT_MURO,423,32,26,13,"Create a polyline at a fixed gap")
	PushButton("RAC",EVENT_SPIGOLO2,311,32,26,13,"Join up 2 selected lines (2 lines or 4 selected vertexes)(C/S)")
	PushButton("XYZ CUR",EVENT_SXYZ,647,32,26,13,"Relative movement  of the 3D cursor on X,Y,Z giving a certain distance")
	PushButton("ORT",EVENT_ORTO,675,32,26,13,"Move the selection in orto mode on the used 3D view")
	PushButton("ESCI",EVENT_ESCI,934,4,60,13,"Exit from the script saving the main data")
	PushButton("CARICA",EVENT_LOAD,934,19,60,13,"Load the main data from the last working session")
	PushButton("SMU",EVENT_ARROTO,283,32,26,13,"Round a vertex betwen two linked lines (C/S)")
	PushButton("OGG",EVENT_PUNTO,3,32,26,13,"Create a new point wherever is located the Cursor (new object)")
	PushButton("OCO",EVENT_PUNTOCOO,31,32,26,13,"Create a new point in the assigned coordinates (new object)")
	PushButton("VERT",EVENT_PUNTO2,59,32,26,13,"Create a new point wherever is located the Cursor (on the active object)")
	PushButton("FIGURE",EVENT_FIGURE,199,32,26,13,"Create 2D geometric figures relative at the selected point")
	PushButton("VDIREZ.",EVENT_DISTANZA,703,32,26,13,"Move the vertexes in a direction (destination MEM SEL)")
	PushButton("PQUOTE",EVENT_QUOTE,619,80,26,13,"Setting for the drawings of quotas")
	PushButton("EXT",EVENT_EXT,647,80,26,13,"Extensions - Library of PROCAD")
	PushButton("PAR",EVENT_PARALLELA,255,32,26,13,"Create a parallel line to Create a parallel line after selecting 2 points")
	PushButton("ELL",EVENT_ELLISSI,171,32,26,13,"Create Ellipses - Polygons - Arches of ellipses")
	PushButton("S>C",EVENT_SNAP1,731,32,26,13,"Object Snap (selected vertex -> 3D Cursor)")
	PushButton("PROIETTA",EVENT_PROIETTA,479,32,26,13,"Projection of the selected vertexes on the 3D view plan at the cursor")
	PushButton("V3D",EVENT_ALLINEA,759,32,26,13,"Align the selected object at the 3D view")
	PushButton("CPA",EVENT_CREACERCHIO3P,87,32,82,13,"Create Circles - Polygons - Arches")
	PushButton("PROCAD",EVENT_INFO,934,49,60,13,"Info keyboard shortcuts of PROCAD")
	PushButton("BLENDER",EVENT_COMANDI,934,34,60,13,"Main info of Blender commands in Edit mode")
	tog2=Toggle("< / >",EVENT_NIENTE,880,19,51,13,tog2.val,"Inverter")
	togscegli=Toggle("C/S",EVENT_NIENTE,880,4,51,13,togscegli.val,"ON=Create point OFF=Move point")
#	togmuovi=Toggle("MUOVIOGGETTO",EVENT_NIENTE,820,49,50,13,togmuovi.val,"Abilita/Disabilita movimento oggetto o selezione con snap")
	togx=Toggle("X",EVENT_NIENTE,880,34,17,13,togx.val,"Enable/Disable alignment of X-axis")
	togy=Toggle("Y",EVENT_NIENTE,897,34,17,13,togy.val,"Enable/Disable alignment of Y-axis")
	togz=Toggle("Z",EVENT_NIENTE,914,34,17,13,togz.val,"Enable/Disable alignment of Z-axis")
	togrem=Toggle("REMDB",EVENT_NIENTE,880,64,51,13,togrem.val,"Execute remove doubles at the end of each command")
	limita=Number("",EVENT_NIENTE,880,49,51,13,limita.val,0.0,1.0,"Reduce the action of RemDoubles")
	frazione=Number("Div.",EVENT_NIENTE,787,34,91,13,frazione.val,0,100,"Precision of line snap")
	misuradata=Number("Mis.",EVENT_NIENTE,787,19,91,13,misuradata.val,0.0,1000.0,"Measure of line snap")
	togsnap=Toggle("SNAP A/S",EVENT_NIENTE,787,4,91,13,togsnap.val,"ON = Snap All    OFF = Snap Selection")
	

def event(evt, val):
	global indicet,mvista,rico,trovato,ob

	if (evt == EKEY and not val):#Esce senza memorizzare i dati
		Exit()
			
	elif (evt == RIGHTMOUSE and not val):# Trova il punto cursore piu' vicino e crea una lista di punti in ordine di distanza
		del trovato[:]
		del ob[:]	
		entra()
		viewMatrix=Window.GetViewMatrix()
		cursorPosition = cursoreinvista()
		sce=Blender.Scene.GetCurrent()
		for obj in sce.objects:
			if obj.type=='Mesh':
				if togsnap==1:# tutti gli oggetti mesh
					ob.append(obj)
				else:# solo oggetti mesh selezionati
					if obj.sel==1:
						ob.append(obj)
		if ob==[]:return
		for r in range (0,len(ob)):
			verts = ob[r].getData().verts 
			oggettoMatrix = ob[r].mat 
			vertsMatrix = oggettoMatrix * viewMatrix
			for punti in range (0,len(verts)):
				lontano=distance2d(cursorPosition, trasforma(verts[punti].co,vertsMatrix))
				valori=[lontano,punti,ob[r]]
				trovato.append(valori)
		trovato.sort()
		rico[24],rico[25],rico[26]=0,0,0
		oggettoMatrix = trovato[0][2].mat
		candidateverts = trovato[0][2].getData().verts 
		result = trasforma(candidateverts[trovato[0][1]].co,oggettoMatrix)
		memcursore(result[0],result[1],result[2])
		# sposta oggetto selezionato
#		if togmuovi==1:
#			esce()
#			spostaoggetto()
#			entra()
		esce()
		Blender.Redraw()
		return

	elif (evt == SKEY and not val):
		memorsel()
		indicet="Acquired selected points"
		Blender.Redraw()
		return

	elif (evt == PAD1 and not val):
		Window.SetViewQuat(mvista[0])
		Window.SetViewOffset(mvista[3])
		indicet="View 1 restored"
		Blender.Redraw()
		return

	elif (evt == PAD2 and not val):
		Window.SetViewQuat(mvista[1])
		Window.SetViewOffset(mvista[4])
		indicet="View 2 restored"
		Blender.Redraw()
		return

	elif (evt == PAD3 and not val):
		Window.SetViewQuat(mvista[2])
		Window.SetViewOffset(mvista[5])
		indicet="View 2 restored"
		Blender.Redraw()
		return

	elif (evt == TKEY and not val):
		testos="TYPE OF CUT%t|Single vertexes|Linked vertexes|"
		n = PupMenu(testos)
		if n<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		taglia(n)
		indicet="Cut lines"
		Blender.Redraw()
		return

	elif (evt == DKEY and not val):
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		me=obj.getData(mesh=1)
		v=me.verts.selected()
		try:
			vv1 = trasform(obj,me.verts[v[0]].co)
			vv2 = trasform(obj,me.verts[v[1]].co)
		except:
			PupMenu("Error%t|Select 2 or more vertexes")
			esce()
			Blender.Redraw()
			return
		nrico[8]=vv2[2]-vv1[2]
		nrico[12]=nrico[8]
		esce()
		indicet="View Delta Z = "+str(nrico[8])+" applied"
		Blender.Redraw()
		return

	elif (evt == WHEELUPMOUSE ):
		entra()
		try:
			if modosnap==1:#vertice
				b=len(trovato)
				a=rico[24]
				a+=1
				if a>b-1:
					a=0
				rico[24]=a
				oggettoMatrix = trovato[a][2].mat
				candidateverts = trovato[a][2].getData().verts 
				result = trasforma(candidateverts[trovato[a][1]].co,oggettoMatrix)
				memcursore(result[0],result[1],result[2])
				# sposta oggetto
			#	if togmuovi==1:
				#	esce()
				#	spostaoggetto()
				#	entra()
			if modosnap==2:#linea divisioni
				div=frazione.val
				posx,posy,posz=mcur[0][0],mcur[0][1],mcur[0][2]
				ax,ay,az=(mcur[0][0]-mcur[1][0])/div,(mcur[0][1]-mcur[1][1])/div,(mcur[0][2]-mcur[1][2])/div
				rico[25]+=1
				if rico[25]>div:
					rico[25]=0
				# non memorizza cursore
				Window.SetCursorPos(posx-(ax*rico[25]),posy-(ay*rico[25]),posz-(az*rico[25]))
				# SPOSTAOGGETTOSELEZIONATO
			#	if togmuovi==1:
			#		esce()
			#		spostaoggetto()
			#		entra()
			if modosnap==3:#linea misura
				f=Vector([mcur[0][0]-mcur[1][0],mcur[0][1]-mcur[1][1],mcur[0][2]-mcur[1][2]]).length
				div=f/misuradata.val
				posx,posy,posz=mcur[0][0],mcur[0][1],mcur[0][2]
				ax,ay,az=(mcur[0][0]-mcur[1][0])/div,(mcur[0][1]-mcur[1][1])/div,(mcur[0][2]-mcur[1][2])/div
				rico[26]+=1
				# non memorizza cursore
				Window.SetCursorPos(posx-(ax*rico[26]),posy-(ay*rico[26]),posz-(az*rico[26]))
				indicet="Distance = "+str(misuradata.val*rico[26])
				# SPOSTAOGGETTOSELEZIONATO
			#	if togmuovi==1:
			#		esce()
			#		spostaoggetto()
			#		entra()
		except:
			esce()
			Blender.Redraw()
			return
		esce()
		Window.Redraw(Window.Types.SCRIPT)
		Blender.Redraw()
		return

	elif (evt == WHEELDOWNMOUSE ):
		entra()
		try:
			if modosnap==1:
				b=len(trovato)
				a=rico[24]
				a-=1
				if a<0:
					a=b-1
				rico[24]=a
				oggettoMatrix = trovato[a][2].mat
				candidateverts = trovato[a][2].getData().verts 
				result = trasforma(candidateverts[trovato[a][1]].co,oggettoMatrix)
				memcursore(result[0],result[1],result[2])
				# sposta oggetto
			#	if togmuovi==1:
			#		esce()
			#		spostaoggetto()
			#		entra()
			if modosnap==2:
				div=frazione.val
				posx,posy,posz=mcur[0][0],mcur[0][1],mcur[0][2]
				ax,ay,az=(mcur[0][0]-mcur[1][0])/div,(mcur[0][1]-mcur[1][1])/div,(mcur[0][2]-mcur[1][2])/div
				rico[25]-=1
				if rico[25]<0:
					rico[25]=div
				# non memorizza cursore
				Window.SetCursorPos(posx-(ax*rico[25]),posy-(ay*rico[25]),posz-(az*rico[25]))
				# SPOSTAOGGETTOSELEZIONATO
			#	if togmuovi==1:
			#		esce()
			#		spostaoggetto()
			#		entra()
			if modosnap==3:#linea misura
				f=Vector([mcur[0][0]-mcur[1][0],mcur[0][1]-mcur[1][1],mcur[0][2]-mcur[1][2]]).length
				div=f/misuradata.val
				posx,posy,posz=mcur[0][0],mcur[0][1],mcur[0][2]
				ax,ay,az=(mcur[0][0]-mcur[1][0])/div,(mcur[0][1]-mcur[1][1])/div,(mcur[0][2]-mcur[1][2])/div
				rico[26]-=1
				# non memorizza cursore
				Window.SetCursorPos(posx-(ax*rico[26]),posy-(ay*rico[26]),posz-(az*rico[26]))
				indicet="Distance = "+str(misuradata.val*rico[26])
				# SPOSTAOGGETTOSELEZIONATO
			#	if togmuovi==1:
			#		esce()
			#		spostaoggetto()
			#		entra()
		except:
			esce()
			Blender.Redraw()
			return
		esce()
		Window.Redraw(Window.Types.SCRIPT)
		Blender.Redraw()
		return

	elif (evt == RKEY and not val):
		raccordare()
		indicet="Lines joined in 1 vertex"
		Blender.Redraw()
		return

	elif (evt == KKEY and not val):
		congiungi()
		indicet="Line joined"
		Blender.Redraw()
		return

	elif (evt == PKEY and not val):
		modo=1
		#1 alla volta
		menu_parallela()
		if blocco==0:
			return
		parallela(modo,0.0,0.0,0.0,0.0,0.0,0.0)
		indicet="Parallel at "+str(ricorda)+" created"
		Blender.Redraw()
		return

	elif (evt == QKEY and not val):
		testos="TYPE OF QUOTA%t|3D Horizontal|2D Horizontal 2D|3D Vertical|2D Vertical|3D Aligned|2D Aligned|"
		testos=testos+"Instruction|Internal Angle|External Angle|Radius|------------|Suffix Quotas|Suffix Angles|Set layers"
		scelta = PupMenu(testos)
		if scelta<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		if scelta==1:#Orizzontale 3D
			quotah(scelta)
		elif scelta==2:#Orizzontale 2D
			quotah(scelta)
		elif scelta==3:#Verticale 3D
			quotav(scelta-2)
		elif scelta==4:#Verticale 2D
			quotav(scelta-2)
		elif scelta==5:#Allineata 3D
			quotao(scelta-4)
		elif scelta==6:#Allineata 2D
			quotao(scelta-4)
		elif scelta==7:#Indicazione
			indicazione()
		elif scelta==8:#Angolo interno
			quotangolo(scelta-8)
		elif scelta==9:#Angolo esterno
			quotangolo(scelta-8)
		elif scelta==10:#indica raggio
			indicaraggio()
		elif scelta==12:#Suffisso quote
			riquote[-1]=PupStrInput("Suffix: ",riquote[-1],20)
		elif scelta==13:#Suffisso angoli
			riquote[-2]=PupStrInput("Suffix: ",riquote[-2],20)
		elif scelta==14:#Setta layer
			riquote[4]=Window.GetActiveLayer()
		indicet="Operation executed"
		Blender.Redraw()
		return

	elif (evt == OKEY and not val):
		modo=0
		#piu' di 1
		menu_parallela()
		if blocco==0:
			return
		dist2=rico[1]
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		data=obj.getData(mesh=1)
		a=data.edges.selected()
		esce()
		for i in xrange (len(a)):
			ve=data.edges[a[i]]
			cove1=data.edges[a[i]].v1
			cove2=data.edges[a[i]].v2
			c1=trasform(obj,cove1.co)
			c2=trasform(obj,cove2.co)
			parallela(modo,c1[0],c1[1],c1[2],c2[0],c2[1],c2[2])
		indicet="Parallels at "+str(ricorda)+" created"
		Blender.Redraw()
		return

	elif (evt == MKEY and not val):
		testos="CREATE OFFSET%t|Internal|External|Central"
		scelta = PupMenu(testos)
		if scelta<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		menu_muro()
		if blocco==0:
			return
		spess=rico[1]
		pieno=memtog[3]
		if scelta==1:#crea interno
			tt="Offset internal to "
			spess*=-1
			muro(spess,pieno)
		elif scelta==2:#crea esterno
			tt="Offset external to "
			muro(spess,pieno)
		elif scelta==3:#crea centrale
			tt="Offset centered of "
			spess=spess/2
			muro(spess,pieno)
			spess=spess*-1
			muro(spess,pieno)
		indicet=tt+str(fabs(spess))+" units"
		Blender.Redraw()
		return

def bevent(evt):
	global cur,mcur,indice,indicet,msel,vsel,rico,nrico,nr,riquote,modosnap
	global mvista

# Esce dallo script e memorizza i principali dati
	if (evt == EVENT_ESCI):
		out=file(os.path.join(dirsrc,"RICO.txt"),"w")
		for a in xrange (len(rico)):
			out.write(str(rico[a])+"\n")
		out.close()
		out=file(os.path.join(dirsrc,"NRICO.txt"),"w")
		for a in xrange (len(nrico)):
			out.write(str(nrico[a])+"\n")
		out.close()
		out=file(os.path.join(dirsrc,"NR.txt"),"w")
		for a in xrange (len(nr)):
			out.write(str(nr[a])+"\n")
		out.close()
		out=file(os.path.join(dirsrc,"MEMTOG.txt"),"w")
		for a in xrange (len(memtog)):
			out.write(str(memtog[a])+"\n")
		out.close()
		out=file(os.path.join(dirsrc,"RIQUOTE.txt"),"w")
		for a in xrange (len(riquote)):
			out.write(str(riquote[a])+"\n")
		out.close()
		Exit()
		
# Esegue script esterno
	elif (evt == EVENT_EXT):
		testos="EXTENSIONS%t|Rib vault|Link rect-circle|Wall with door|Wall with window|"
		scelta = PupMenu(testos)
		if scelta<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		if scelta==1:
			Blender.Run(os.path.join(dirsrc,"estensioni","VOLTAC2.py"))
			Blender.Redraw()
			return
		if scelta==2:
			Blender.Run(os.path.join(dirsrc,"estensioni","RECT-CIRCLE.py"))
			Blender.Redraw()
			return
		if scelta==3:
			Blender.Run(os.path.join(dirsrc,"estensioni","WALL_DOOR.py"))
			Blender.Redraw()
			return
		if scelta==4:
			Blender.Run(os.path.join(dirsrc,"estensioni","WALL_WINDOW.py"))
			Blender.Redraw()
			return

# Allinea
	elif (evt == EVENT_ALLINEA2):
		testos="ALIGNMENT%t|Horizontal|Vertical"
		scelta = PupMenu(testos)
		if scelta<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		ms=[(0.0,0.0,0.0),(0.0,0.0,0.0)]
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		me=obj.getData(mesh=1)
		v=me.verts.selected()
		ms[0]=trasform(obj,msel[0])
		ms[1]=trasform(obj,msel[1])
		for a in range (0,len(v)):
			vert1=me.verts[v[a]]
			vertice1=trasform(obj,vert1.co)
			p1=Vector(ms[0][0],ms[0][1],0)
			p2=Vector(ms[1][0],ms[1][1],0)
			p3=Vector(vertice1[0],vertice1[1],0)
			if scelta==2:
				p4=Vector(vertice1[0],vertice1[1]-1.0,0)
			else:
				p4=Vector(vertice1[0]-1.0,vertice1[1],0)
			g=LineIntersect(p1,p2,p3,p4)
			vertok=g[0][0],g[0][1],vertice1[2]
			vertok=trasform2(obj,Vector(vertok))	
			me.verts[v[a]].co[0],me.verts[v[a]].co[1],me.verts[v[a]].co[2]=vertok[0],vertok[1],vertok[2]
		esce()
		indicet="Alignment completed"
		Blender.Redraw()
		return

# Carica i dati dall'ultima sessione di lavoro
	elif (evt == EVENT_LOAD):
		try:
			inp=file(os.path.join(dirsrc,"RICO.txt"),"r")
			for a in xrange (len(rico)):
				rico[a]=float(inp.readline())
			inp.close()
			rico[0],rico[4],rico[6]=int(rico[0]),int(rico[4]),int(rico[6])
			rico[24],rico[25],rico[26]=0,0,0
			inp=file(os.path.join(dirsrc,"NRICO.txt"),"r")
			for a in xrange (len(nrico)):
				nrico[a]=float(inp.readline())
			inp.close()
			nrico[6],nrico[13],nrico[20],nrico[21],nrico[22]=int(nrico[6]),int(nrico[13]),int(nrico[20]),int(nrico[21]),int(nrico[22])
			inp=file(os.path.join(dirsrc,"NR.txt"),"r")
			for a in xrange (len(nr)):
				nr[a]=float(inp.readline())
			inp.close()
			nr[6]=int(nr[6])
			inp=file(os.path.join(dirsrc,"MEMTOG.txt"),"r")
			for a in xrange (len(memtog)):
				memtog[a]=int(inp.readline())
			inp.close()
			inp=file(os.path.join(dirsrc,"RIQUOTE.txt"),"r")
			for a in xrange (len(riquote)-2):
				riquote[a]=float(inp.readline())
			riquote[-2]=inp.readline()
			riquote[-1]=inp.readline()
			inp.close()
			riquote[4],riquote[5],riquote[7]=int(riquote[4]),int(riquote[5]),int(riquote[7])
			indicet="Main data loaded"
			Blender.Redraw()
		except:
			indicet="Main data not loaded"
			Blender.Redraw()
			return
	
# Memorizza vista 3D
	elif (evt == EVENT_MEMOVISTA):
		testos="SAVE IN POSITION%t|1|2|3"
		scelta = PupMenu(testos)
		if scelta<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		mvista[scelta-1]=Window.GetViewQuat()
		mvista[scelta+2]=Window.GetViewOffset()
		indicet="Vies saved in position "+str(scelta)
		Blender.Redraw()
		return
		
# Dimenziona una selezione in edit mode
	elif (evt == EVENT_DIMENSION):
		xlist=[]
		ylist=[]
		zlist=[]
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		me=obj.getData(mesh=1)
		v=me.verts.selected()
		for a in range (0,len(v)):
			xlist.append(me.verts[v[a]].co[0])
			ylist.append(me.verts[v[a]].co[1])
			zlist.append(me.verts[v[a]].co[2])
		xlist.sort()
		ylist.sort()
		zlist.sort()
		dimx=xlist[-1]-xlist[0]
		dimy=ylist[-1]-ylist[0]
		dimz=zlist[-1]-zlist[0]
		nrico[17]=dimx
		nrico[18]=dimy
		nrico[19]=dimz
		menu_scala()
		if blocco==0:
			esce()
			return
		try:
			moltx=nrico[17]/dimx
		except:
			moltx=nrico[17]
		try:
			molty=nrico[18]/dimy
		except:
			molty=nrico[18]
		try:
			moltz=nrico[19]/dimz
		except:
			moltz=nrico[19]
		for a in range (0,len(v)):
			vx=me.verts[v[a]].co[0]
			vy=me.verts[v[a]].co[1]
			vz=me.verts[v[a]].co[2]
			if nrico[20]==1:
				me.verts[v[a]].co[0]=(vx-msel[0][0])*moltx+msel[0][0]
				me.verts[v[a]].co[1]=(vy-msel[0][1])*molty+msel[0][1]
				me.verts[v[a]].co[2]=(vz-msel[0][2])*moltz+msel[0][2]
			else:
				me.verts[v[a]].co[0]=vx*moltx
				me.verts[v[a]].co[1]=vy*molty
				me.verts[v[a]].co[2]=vz*moltz
#       trasposizione oggetti selezionati (devono essere imparentati)
		obj2=Object.GetSelected()
		if len(obj2)>1:
			if nrico[20]==1:
				for t in range (1,len(obj2)):	
					a=obj2[t].loc
					obj2[t].LocX=(a[0]-obj.LocX-msel[0][0])*moltx+obj.LocX+msel[0][0]
					obj2[t].LocY=(a[1]-obj.LocY-msel[0][1])*molty+obj.LocY+msel[0][1]
					obj2[t].LocZ=(a[2]-obj.LocZ-msel[0][2])*moltz+obj.LocZ+msel[0][2]
			else:
				for t in range (1,len(obj2)):	
					a=obj2[t].loc
					obj2[t].LocX=(a[0]-obj.LocX)*moltx+obj.LocX
					obj2[t].LocY=(a[1]-obj.LocY)*molty+obj.LocY
					obj2[t].LocZ=(a[2]-obj.LocZ)*moltz+obj.LocZ
		esce()
		indicet="Sizing completed"
		Blender.Redraw()
		return

# Proietta selezione su una faccia selezionata con MSEL
	elif (evt == EVENT_TOFACE):
		allineafaccia()
		indicet="Projection on the face completed"
		Blender.Redraw()
		return

# Proietta selezione su una linea selezionata con MSEL
	elif (evt == EVENT_TOLINE):
		allinealinea()
		indicet="Projection on the line completed"
		Blender.Redraw()
		return

# Muovi selezione in orto mode
	elif (evt == EVENT_ORTO):
		menu_muoviorto()
		if blocco==0:
			return
		muoviortovista()
		indicet="Ortogonal movement in view completed"
		Blender.Redraw()
		return

# Modo snap cursore 3D
	elif (evt == EVENT_MODOSNAP):
		testos="TYPE OF SNAP MOUSE WHEEL%t|Vertex|Line (divisions)|Line (measure)"
		scelta = PupMenu(testos)
		if scelta<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		modosnap=scelta

# Crea spessore
	elif (evt ==EVENT_MURO):
		testos="CREATE OFFSET%t|Internal|External|Central"
		scelta = PupMenu(testos)
		if scelta<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		menu_muro()
		if blocco==0:
			return
		spess=rico[1]
		pieno=memtog[3]
		if scelta==1:#crea interno
			tt="Offset internal to "
			spess*=-1
			muro(spess,pieno)
		elif scelta==2:#crea esterno
			tt="Offset external to "
			muro(spess,pieno)
		elif scelta==3:#crea centrale
			tt="Offset centred of "
			spess=spess/2
			muro(spess,pieno)
			spess=spess*-1
			muro(spess,pieno)
		indicet=tt+str(fabs(spess))+" units"
		Blender.Redraw()
		return

# Taglia linee
	elif (evt == EVENT_TAGLIA):
		testos="TYPE OF CUT%t|Singles vertexes|Joined vertexes|"
		n = PupMenu(testos)
		if n<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		taglia(n)
		indicet="Lines cut"
		Blender.Redraw()
		return

# Info key PROCAD
	elif (evt == EVENT_INFO):
		testos="PROCAD KEYS%t|E = Exit without saving data|S = Save Selected|P = Parallel of 2 vertexes|O = Parallel multiple (lines)|"
		testos=testos+"R = Joined 2 lines|M = Create offset|K = Link|"
		testos=testos+"Q = Draw quota|D = Save delta Z of 2 vertexes sel.|T = Cut|"
		testos=testos+"NUMPAD 1-2-3 = Restore view|R MOUSE = Find snap point|WHEEL UP = Snap forward|WHEEL DOWN = Snap previous|"
		PupMenu(testos)

# Info comandi Blender
	elif (evt == EVENT_COMANDI):
		testos="MAIN BLENDER COMMANDS%t|A-A = Select-Deselect all|B-B = Select a portion in a window-circle|G = Move(=Grab) the selection|"
		testos=testos+"R = Rotate selection|S = Size selection|M = Mirror|E = Extrude selection (create line)|Alt+M = Join vertexes|"
		testos=testos+"F = Create line-face between 2-3 selected vertexes|SHIFT+D = Duplicate the selection|SHIFT+S = Snap functions|"
		testos=testos+"K = Cutter|CTRL = Snap magnet|Numpad = Views|* Numpad = Align the view to the selection|C = Center the view to the 3D cursor"
		PupMenu(testos)

# Ellissi
	elif (evt == EVENT_ELLISSI):
		testos="ELLIPSE-POLYGON-ARC OF ELLIPS%t|EPA - Center, X-Radius, Y-Radius|EPA - Center, X-Diameter, Y-Diameter|"
		testos+="EPA - 2 Points on the X-radius|EPA - 2 Points on the X-Diameter|"
		ellis = PupMenu(testos)
		if ellis<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		testo="Radius"
		if ellis==2 or ellis==4:
			testo="Diameter"
		menu_ellissi(testo)
		if blocco==0:
			return
		if ellis==1:#Centro sel, RX, RY
			n=1
			ellissi(n)
			indicet="EPA --> Center, RX, RY - Angle= "+str(rico[21])
			Blender.Redraw()
		if ellis==2:#Centro sel, DX, DY
			n=2
			ellissi(n)
			indicet="EPA --> Center, DX, DY - Angle= "+str(rico[21])
			Blender.Redraw()
		if ellis==3:#2 Punti sel. sul Raggio X.
			n=3
			ellissi(n)
			indicet="EPA --> 2 Points sel. on RX - Angle= "+str(rico[21])
			Blender.Redraw()
		if ellis==4:#2 Punti sel. sul Diametro X.
			n=4
			ellissi(n)
			indicet="EPA --> 2 Points sel. on DX - Angle= "+str(rico[21])
			Blender.Redraw()

# Menu quote
	elif (evt == EVENT_QUOTE):
		menu_quote()
		if blocco==0:
			return

# Misurazioni
	elif (evt == EVENT_DISEGNA2):
		testos="MEASUREMENTS%t|M1-M2 and selected vertex|"
		testos+="Selected lines|---------------|Decimal rounding|"
		misuraz = PupMenu(testos)
		if misuraz<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		if misuraz==1:#misura cursore
			indicet="Measurement M1-M2 and selected vertex"
			Blender.Redraw()
			Misura()
		elif misuraz==2:#misura linee selezionate:
			ll=0.0
			entra()
			obj=Object.GetSelected()
			if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
			else:PupMenu("Error%t|Mesh Object not selected");return
			mes=obj.getData(mesh=1)
			a=mes.edges.selected()
			for i in xrange(len(a)):
				ll+=Vector(mes.edges[a[i]].v1.co[0]-mes.edges[a[i]].v2.co[0],mes.edges[a[i]].v1.co[1]-mes.edges[a[i]].v2.co[1],mes.edges[a[i]].v1.co[2]-mes.edges[a[i]].v2.co[2]).length
			esce()
			indicet="Total length = "+str(arrot(ll))
			Blender.Redraw()
		elif misuraz==4:#inserisci arrotondamento:
			dato=PupIntInput("Decimals=",nrico[22],0,6)
			if dato==None:
				PupMenu("Error%t|Insert the digit number of decimals")
				return
			nrico[22]=dato

# Undo cursore
	elif (evt == EVENT_UNDCUR):
		indice+=1
		if indice>19:
			PupMenu("Error%t|Undo ends")
			indice=19
		Window.SetCursorPos(mcur[indice])
		indicet="Undo 3D Cursor --> "+str(indice)
		Blender.Redraw()

# Congiungi
	elif (evt == EVENT_CONGIUNGI):
		congiungi()
		indicet="Line joined"
		Blender.Redraw()

# Redo cursore
	elif (evt == EVENT_REDCUR):
		indice-=1
		if indice<0:
			PupMenu("Error%t|Redo ends")
			indice=0
		Window.SetCursorPos(mcur[indice])
		indicet="Redo 3D Cursor --> "+str(indice)
		Blender.Redraw()

# Acquisisci Cursore
	elif (evt == EVENT_P1):
		cursore()
		indicet="Cursor position acquired"
		Blender.Redraw()
		
# Acquisisci Selezionato
	elif (evt == EVENT_S):
		memorsel()
		indicet="Selected points acquired"
		Blender.Redraw()

# Sposta il cursore sull'asse X,Y,Z 
	elif (evt == EVENT_SXYZ):
		ttt=""
		viewMatrix=Window.GetViewMatrix()
		cuvi=cursoreinvista()
		dist2=PupFloatInput("Distance=",rico[3],-1000.0,1000.0,100,3)
		if dist2==None:
			PupMenu("Error%t|Insert a value")
			return
		rico[3]=dist2
		if togx.val:
			cuvi[0]+=dist2
			ttt+="X"
		if togy.val:
			cuvi[1]+=dist2
			ttt+="Y"
		if togz.val:
			cuvi[2]+=dist2
			ttt+="Z"
		cuvi=trasforma(cuvi,viewMatrix.invert())
		memcursore(cuvi[0],cuvi[1],cuvi[2])
		indicet="Cursor moved of "+str(dist2)+" units in "+ttt
		Blender.Redraw()

# Crea una linea dal punto selezionato alle coor. polari 
	elif (evt == EVENT_CREAPOLARE):
		menu_polare()
		if blocco==0:
			return
		lungh,ango,angofi=rico[7],rico[8],rico[9]
		if ango<0.0:
			ango=360.0+ango
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		me=obj.getData(mesh=1)
		ver=me.verts.selected()
		xyz1=trasform(obj,me.verts[ver[0]].co)
		ms0=trasform(obj,msel[0])
		distazimut(xyz1[0],xyz1[1],ms0[0],ms0[1])
		correzione=diaz[1]
		if memtog[4]==1:
			ango+=correzione
	# 	Calcolo coordinate 3D con lunghezza sul piano xy
		if tog.val:
			lungdiag=lungh/cos(radians(angofi))
			lp=lungh
			xyz1[2]+=(lungdiag*sin(radians(angofi)))
	# 	Calcolo coordinate 3D con lunghezza nello spazio 3D
		else:		
			lp=lungh*cos(radians(angofi))
			xyz1[2]+=(lungh*sin(radians(angofi)))
		xyz1[0]+=sin(radians(ango))*lp
		xyz1[1]+=cos(radians(ango))*lp
		me.verts.extend(xyz1[0],xyz1[1],xyz1[2])
		me.edges.extend(me.verts[-1],me.verts[ver[0]])
		me.verts[-1].co=trasform2(obj,me.verts[-1].co)
		me.verts[ver[0]].sel=0
		me.verts[-1].sel=1
		esce()
		indicet="Polar line created"
		Blender.Redraw()

# Crea una linea perpendicolare al segmento M1-M2 passante per il cursore 3D 
	elif (evt == EVENT_PERPENDICOLARE):
		viewMatrix=Window.GetViewMatrix()
		lp=PupFloatInput("Ortho.Distance.=",rico[2],-1000.0,1000.0,100,3)
		if lp==None:
			PupMenu("Error%t|Insert a distance")
			return
		rico[2]=lp
		creavertice()
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		me = obj.getData(mesh=1)
		m1 = trasforma(mcur[0],viewMatrix)
		m2 = trasforma(mcur[1],viewMatrix)
		me.verts[-1].co=trasform(obj,me.verts[-1].co)
		distazimut(m1[0],m1[1],m2[0],m2[1])
		angolo=diaz[1]+90.0
		x=me.verts[-1].co[0]+sin(radians(angolo))*lp
		y=me.verts[-1].co[1]+cos(radians(angolo))*lp
		me.verts.extend(x,y,me.verts[-1].co[2])
		me.edges.extend(me.verts[-1],me.verts[-2])
		me.verts[-1].co=trasform2(obj,me.verts[-1].co)
		me.verts[-2].co=trasform2(obj,me.verts[-2].co)
		esce()
		indicet="Orthogonal line created"
		Blender.Redraw()

# Crea un nuovo vertice (nuovo oggetto)
	elif (evt == EVENT_PUNTO):
		cuvi=cursoreinvista()
		sce=Blender.Scene.GetCurrent()
		entra()
		obj = Object.New('Mesh')
		sce.link(obj)
		obj.sel=1
		me=obj.getData(mesh=1)
		cuvi=trasform2(obj,cuvi)
		me.verts.extend(cuvi[0],cuvi[1],cuvi[2])
		me.verts[0].sel=1
		Window.EditMode(1)												
		indicet="New vertex object created"
		Blender.Redraw()
	
# Crea un nuovo vertice tramite coordinate(nuovo oggetto)
	elif (evt == EVENT_PUNTOCOO):
		menu_vertice()
		if blocco==0:
			return
		xc,yc,zc=nrico[9],nrico[10],nrico[11]
		sce=Blender.Scene.GetCurrent()
		entra()
		obj = Object.New('Mesh')
		sce.link(obj)
		obj.sel=1
		me=obj.getData(mesh=1)
		me.verts.extend(xc,yc,zc)
		me.verts[0].sel=1
		me.verts[0].co=trasform2(obj,me.verts[0].co)
		Window.SetCursorPos(me.verts[0].co[0],me.verts[0].co[1],me.verts[0].co[2])
		Window.EditMode(1)												
		indicet="New vertex object created"
		Blender.Redraw()
	
# Crea un nuovo vertice (oggetto selezionato)
	elif (evt == EVENT_PUNTO2):
		creavertice()
		indicet="New vertex created"
		Blender.Redraw()
	
# Snap oggetto
	elif (evt == EVENT_SNAP1):
		indicet="Snap Vert.sel. --> 3D Cursore executed"
		spostaoggetto()
		Blender.Redraw()
	
# Spigolo
	elif (evt == EVENT_SPIGOLO):
		memorsel()
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		data=obj.getData(mesh=1)
		#trasformazione
		ms0=trasform(obj,msel[0])
		ms1=trasform(obj,msel[1])
		pts=data.verts.selected()
		if len(pts) != 2 :
			PupMenu("Error%t|Select 2 points")
			esce()
			Blender.Redraw()
			return
		if tog2.val:
			if togz.val:data.verts.extend(ms1[0],ms0[1],ms0[2])
			else:data.verts.extend(ms1[0],ms0[1],ms1[2])
		else:
			if togz.val:data.verts.extend(ms0[0],ms1[1],ms0[2])
			else:data.verts.extend(ms0[0],ms1[1],ms1[2])
		data.verts[vsel[0]].sel=0
		data.verts[vsel[1]].sel=0
		data.verts[-1].sel=1
		data.verts[-1].co=trasform2(obj,data.verts[-1].co)
		if togscegli.val==1:
			data.edges.extend(data.verts[vsel[0]],data.verts[-1])
			data.edges.extend(data.verts[vsel[1]],data.verts[-1])
  		esce()
		indicet="Edge created"
		Blender.Redraw()

# Allinea su 3D view
	elif (evt == EVENT_ALLINEA):
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		matr=Window.GetViewMatrix()
		obj.setMatrix(matr.invert())
  		esce()
		indicet="Aligned object on the 3D view"
		Blender.Redraw()

# Raccorda
	elif (evt == EVENT_SPIGOLO2):
		indicet="Joined lines in 1 vertex"
		Blender.Redraw()
		raccordare()

# Arrotonda
	elif (evt == EVENT_ARROTO):
		menu_arrotondare()
		if blocco==0:
			return
		indicet="Rounding executed"
		Blender.Redraw()
		arrotondare()

# Crea poligono inscritto o circoscritti al cerchio 
	elif (evt == EVENT_CREACERCHIO3P):
		global ricorda
		testos="CIRCLE-POLYGON-ARC%t|CPA - Through 3 points|CPA - 2 points on the diameter|"
		testos=testos+"CPA - 2 points on the radius|CPA - Center and radius|CPA - Center and diameter|CPA - 2 points and radius|"
		testos=testos+"_PA - 2 furthest points and radius|CPA - Center 3D Cursor and beginning of selection|CPA - Identify the center from 3 points|"
		testos=testos+"_PA - Center 3D Cursor,beginning,end|CPA - Center and area|CPA - Center and perimeter|CPA - Center and side of polygon|"
		cerchio = PupMenu(testos)
		testo="Raggio = "
		if cerchio<1:
			PupMenu("Error%t|Insert a soluction")
			Blender.Redraw()
			return
		if cerchio==5:
			testo="Diametro = "
		if cerchio==9:
			cerchio3p(0.0,1)
			indicet="Identified Center - Radius = "+str(rico[6])
			Blender.Redraw()
			return
		menu_cpa(testo)
		if blocco==0:
			return
		ango=rico[14]
		if cerchio==1:
			indicet="CPA --> through 3 points"
			Blender.Redraw()
			nn=0
			cerchio3p(ango,nn)
			rico[14]=360.0 
		elif cerchio==2:
			indicet="CPA --> 2 points on the diameter"
			Blender.Redraw()
			n=1
			cerchiodiam(n,testo,ango) 
		elif cerchio==3:
			indicet="CPA --> 2 points on the radius"
			Blender.Redraw()
			n=2
			cerchiodiam(n,testo,ango) 
		elif cerchio==4:
			indicet="CPA --> Center and radius"
			Blender.Redraw()
			n=4
			cerchiodiam(n,testo,ango) 
		elif cerchio==5:
			indicet="CPA --> Center and diameter"
			Blender.Redraw()
			n=5
			cerchiodiam(n,testo,ango) 
		elif cerchio==6:
			indicet="CPA --> 2 points and radius"
			Blender.Redraw()
			n=3
			cerchiodiam(n,testo,ango) 
		elif cerchio==7:
			indicet="PA --> 2 furthest and radius"
			Blender.Redraw()
			n=6
			ango=360.0
			cerchiodiam(n,testo,ango) 
		elif cerchio==8:
			indicet="CPA --> 3D Cursor Center and selection"
			Blender.Redraw()
			n=10
			cerchiodiam(n,testo,ango) 
		elif cerchio==10:
			arco2() 
			indicet="PA --> Arc of radius "+str(ricorda)+" executed"
			Blender.Redraw()
		elif cerchio==11:
			n=7
			cerchiodiam(n,testo,ango) 
			indicet="CPA --> Center and area of "+str(rico[22])+" square units"
			Blender.Redraw()
		elif cerchio==12:
			n=8
			cerchiodiam(n,testo,ango) 
			indicet="CPA --> Center and perimeter of "+str(rico[23])+" units"
			Blender.Redraw()
		elif cerchio==13:
			n=9
			cerchiodiam(n,testo,ango) 
			indicet="CPA --> Center and side of "+str(nrico[1])+" units"
			Blender.Redraw()

# Crea figure geometriche relative al punto selezionato 
	elif (evt == EVENT_FIGURE):
		testos="GEOMETRIC FIGURES%t|Rectangle o Square|Rectangle Trapezoid|"
		testos=testos+"Isosceles trapezoid|Rhombus|Rectangle Triangle|Isosceles triangle|"
		testos=testos+"uso futuro|uso futuro|uso futuro|"
		figu = PupMenu(testos)
		if figu<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		if figu==1:
			n=1
			figure(n) 
			indicet="Area = "+str(fabs(arrot(ricorda)))
			Blender.Redraw()
		elif figu==2:
			n=2
			figure(n) 
			indicet="Area = "+str(fabs(arrot(ricorda)))
			Blender.Redraw()
		elif figu==3:
			n=3
			figure(n) 
			indicet="Area = "+str(fabs(arrot(ricorda)))
			Blender.Redraw()
		elif figu==4:
			n=4
			figure(n) 
			indicet="Area = "+str(fabs(arrot(ricorda)))
			Blender.Redraw()
		elif figu==5:
			n=5
			figure(n) 
			indicet="Area = "+str(fabs(arrot(ricorda)))
			Blender.Redraw()
		elif figu==6:
			n=6
			figure(n) 
			indicet="Area = "+str(fabs(arrot(ricorda)))
			Blender.Redraw()

# Crea linea parallela a 2 punti selezionati 
	elif (evt == EVENT_PARALLELA):
		modo=1
		ricorda=0
		menu_parallela()
		if blocco==0:
			return
		parallela(modo,0.0,0.0,0.0,0.0,0.0,0.0)
		indicet="Parallel to "+str(ricorda)+" created"
		Blender.Redraw()

# Sposta uno o piu' vertici selezionati verso una direzione 
	elif (evt == EVENT_DISTANZA):
		testos="MOVING TO A DIRECTION%t|Move v.sel. to a fixed distance|"
		testos=testos+"Create v.sel. to a fixed distance|"
		testos=testos+"Move v.sel. to a fixed relative distance in function of v.sel.|"
		testos=testos+"Create v.sel. to a fixed relative distance at v.sel.|"
		testos=testos+"Move v.sel. on a direction respecting a fixed distance|"
		testos=testos+"Create v.sel. on a direction respecting a fixed distance|"
		testos=testos+"Move v.sel. on a direction respecting a relative fixed distance in function of v.sel.|"
		testos=testos+"Create v.sel. on a direction respecting a relative fixed distance in function of v.sel.|"
		spost = PupMenu(testos)
		if spost<1:
			PupMenu("Error%t|Make a selection")
			Blender.Redraw()
			return
		lungh=PupFloatInput("Distance=",rico[18],-1000.0,1000.0,100,3)
		if lungh==None:
			PupMenu("Error%t|Insert a distance")
			return
		rico[18]=lungh
		if spost==1:
			modo=0
			distanza(modo,lungh)
		elif spost==2:
			modo=1
			distanza(modo,lungh)
		elif spost==3:
			modo=2
			distanza(modo,lungh)
		elif spost==4:
			modo=3
			distanza(modo,lungh)
		elif spost==5:
			modo=4
			distanza(modo,lungh)
		elif spost==6:
			modo=5
			distanza(modo,lungh)
		elif spost==7:
			modo=6
			distanza(modo,lungh)
		elif spost==8:
			modo=7
			distanza(modo,lungh)
		indicet="Vertice/i a "+str(lungh)+" unita'"
		Blender.Redraw()

# Proiezione sul piano vista 3D 
	elif (evt == EVENT_PROIETTA):
		sce=Blender.Scene.GetCurrent()
		cuvi=cursoreinvista()
		entra()
		obj=Object.GetSelected()
		if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
		else:PupMenu("Error%t|Mesh Object not selected");return
		obj2 = Object.New('Mesh')
		sce.link(obj2)
		me2=obj2.getData(mesh=1)
		me=obj.getData(mesh=1)
		for i in range (0,(len(me.verts))):
			if me.verts[i].sel >0:
				me.verts[i].co=trasform(obj,me.verts[i].co)
				me2.verts.extend(me.verts[i].co[0],me.verts[i].co[1],cuvi[2])
				me.verts[i].co=trasform2(obj,me.verts[i].co)
		for i in range (0,(len(me2.verts))):
			me2.verts[i].co=trasform2(obj,me2.verts[i].co)
		me2.transform(obj.matrix)
		esce()
		indicet="Projection in 3D view to the 3D cursor position"
		Blender.Redraw()


Register(draw, event, bevent)

#########################################
#########################################
#########################################
#               fine                    #
#########################################
#########################################
#########################################

def arrot(misura):
	misura=ceil(misura*pow(10,nrico[22]))/pow(10,nrico[22])
	return misura

def cursore():
	# acquisisce posizione reale del cursore e la memorizza
	global indice
	cc=Window.GetCursorPos()
	mcur.insert(0,cc)
	del mcur[-1]
	indice=0
	Blender.c1=mcur[0]
	Blender.c2=mcur[1]

def memcursore(x,y,z):
	# posiziona cursore in un dato punto	
	global indice
	cur=[x,y,z]
	mcur.insert(0,cur)
	del mcur[-1]
	indice=0
	Window.SetCursorPos(x,y,z)
	Blender.c1=mcur[0]
	Blender.c2=mcur[1]
	
def entra():
	global editmode
	editmode=Window.EditMode()
  	if editmode: Window.EditMode(0)	
		
def esce():
	global editmode
	if editmode: Window.EditMode(1)												
 	
def spostaoggetto():
#	sposta oggetto selezionato sul cursore 3d
	entra()
	cu=Window.GetCursorPos()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	pts=data.verts.selected()
	correzioni=obj.getLocation()
	cu[0]-=correzioni[0]
	cu[1]-=correzioni[1]
	cu[2]-=correzioni[2]
	cvec=Vector(cu)
	mat=obj.mat.rotationPart()
	mat.invert()
	cc1=cvec*mat
	cx,cy,cz=(cc1[0]-data.verts[pts[0]].co[0]),(cc1[1]-data.verts[pts[0]].co[1]),(cc1[2]-data.verts[pts[0]].co[2])
	for i in range (0,(len(data.verts))):
		data.verts[i].co[0]+=cx		
		data.verts[i].co[1]+=cy		
		data.verts[i].co[2]+=cz		
 	esce()

def distazimut(x1,y1,x2,y2):
	global diaz
	delty=y2-y1
	deltx=x2-x1
	if delty==0.0:
		if deltx>=0.0:teta=90.0
		elif deltx<=0.0:teta=270.0
		d12=fabs(deltx)
		diaz=[d12,teta]
		return diaz
	elif deltx==0.0:
		if delty>=0.0:teta=0.0
		elif delty<=0.0:teta=180.0
		d12=fabs(delty)
		diaz=[d12,teta]
		return diaz
	else:
		d12=hypot(deltx,delty)
		teta=fabs(degrees(atan(deltx/delty)))
		if deltx>0.0 and delty<0.0:teta=180.0-teta
		if deltx<0.0 and delty<0.0:teta=180.0+teta
		if deltx<0.0 and delty>0.0:teta=360.0-teta
		diaz=[d12,teta]
		return diaz

def creavertice():
	cuvi=cursoreinvista()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	me.verts.extend(cuvi[0],cuvi[1],cuvi[2])
	me.verts[-1].co=trasform2(obj,me.verts[-1].co)
	esce() 		
	Blender.Redraw()
	
def Misura():
	co1=mcur[0]
	co2=mcur[1]
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	matr=obj.mat
	try:
		vert=data.verts.selected()
		cov=data.verts[vert[0]].co
		cov=trasforma(cov,matr)
	except:
		PupMenu("Vertex not selected%t|It is considered the origin of the object as vertex")
		cov=trasforma(Vector(0.0,0.0,0.0),matr)
	esce()
	try:
		distM1V=Vector([co1[0]-cov[0],co1[1]-cov[1],co1[2]-cov[2]]).length
		distM2V=Vector([co2[0]-cov[0],co2[1]-cov[1],co2[2]-cov[2]]).length
		distM1M2=Vector([co1[0]-co2[0],co1[1]-co2[1],co1[2]-co2[2]]).length
		angM1=AngleBetweenVecs(Vector([co1[0]-cov[0],co1[1]-cov[1],co1[2]-cov[2]]),Vector([co1[0]-co2[0],co1[1]-co2[1],co1[2]-co2[2]]))
		angM2=AngleBetweenVecs(Vector([co2[0]-cov[0],co2[1]-cov[1],co2[2]-cov[2]]),Vector([co1[0]-co2[0],co1[1]-co2[1],co1[2]-co2[2]]))
		angV=AngleBetweenVecs(Vector([co1[0]-cov[0],co1[1]-cov[1],co1[2]-cov[2]]),Vector([co2[0]-cov[0],co2[1]-cov[1],co2[2]-cov[2]]))
		if angM1>180.0:angM1=360.0-angM1
		if angM2>180.0:angM2=360.0-angM2
		if angV>180.0:angV=360.0-angV
	except:
		PupMenu("Operation not allowed%t|2 or 3 vertexes have the same coordinates")
		return
	distM1V=arrot(distM1V)
	distM2V=arrot(distM2V)
	distM1M2=arrot(distM1M2)
	angM1=arrot(angM1)
	angM2=arrot(angM2)
	angV=arrot(angV)
	# scrive testo
	testos="3D DATA CALCULATED "+"%t|"+"M1-V = "+str(distM1V)+" - Units"+"|"+"M2-V = "+str(distM2V)+" - Units"+"|"+"M1-M2= "+str(distM1M2)+" - Units"+"|"+"A-V= "+str(angV)+" - Degree"
	testos=testos+"|"+"A-M1= "+str(angM1)+" - Degree"
	testos=testos+"|"+"A-M2= "+str(angM2)+" - Degree"
	testos=testos+"|"+"XYZ-M1= "+str(co1[0])+"   "+str(co1[1])+"   "+str(co1[2])
	testos=testos+"|"+"XYZ-M2= "+str(co2[0])+"   "+str(co2[1])+"   "+str(co2[2])
	testos=testos+"|"+"XYZ-V= "+str(cov[0])+"   "+str(cov[1])+"   "+str(cov[2])
	Blender.Draw.PupMenu(testos)	
	Blender.Redraw()

def memorsel():
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	ver=data.verts.selected()
	for i in range (0,(len(ver))):
		s=(data.verts[ver[i]].co[0],data.verts[ver[i]].co[1],data.verts[ver[i]].co[2])
		msel.insert(0,s)
		vsel.insert(0,ver[i])
		del msel[-1]
		del vsel[-1]
		Blender.s1=msel[0]
		Blender.s2=msel[1]
		indice=0
	esce()

def cerchio(obj,dd,xc,yc,zc,ra,spi,x1p,y1p,z1p,ango):
	ripet=1
	distazimut(xc,yc,x1p,y1p)
	teta1v=diaz[1]
	if tog3.val==0:
		ra=ra/sin(radians(90-(ango/(spi*2))))
		xnp=xc+(ra*sin(radians(teta1v)))
		ynp=yc+(ra*cos(radians(teta1v)))
		dd.verts.extend(xnp,ynp,z1p)
	ango=ango/spi
	for s in range (1,(spi+1)):
		ripet+=1
		if tog4.val>0:
			ra+=nr[4]
			if ripet==nr[6]:
				ra+=nr[5]
				xnp=xc+(ra*sin(radians(teta1v+ango*s)))+(nr[2]*s)
				ynp=yc+(ra*cos(radians(teta1v+ango*s)))+(nr[3]*s)
				ra-=nr[5]
				ripet=0	
			else:
				xnp=xc+(ra*sin(radians(teta1v+ango*s)))+(nr[2]*s)
				ynp=yc+(ra*cos(radians(teta1v+ango*s)))+(nr[3]*s)
		else:
			ra+=nr[4]
			if ripet==nr[6]:
				ra+=nr[5]
				xnp=xc+(ra*sin(radians(teta1v-ango*s)))+(nr[2]*s)
				ynp=yc+(ra*cos(radians(teta1v-ango*s)))+(nr[3]*s)
				ra-=nr[5]
				ripet=0	
			else:
				xnp=xc+(ra*sin(radians(teta1v-ango*s)))+(nr[2]*s)
				ynp=yc+(ra*cos(radians(teta1v-ango*s)))+(nr[3]*s)
		dd.verts.extend(xnp,ynp,z1p+(nr[0]*s))
		dd.edges.extend(dd.verts[-2],dd.verts[-1])
	for s in range (1,(spi+2)):
		dd.verts[-s].co=trasform2(obj,dd.verts[-s].co)
	# stampa valori
	print
	print"-----CIRCLE-----"
	print"X,Y,Z CENTER (3D VIEW)= ",xc,yc,zc
	print"RADIUS                 = ",ra
	print"ANGLE OF ARC           = ",ango*spi

def raccordare():
	memorsel()
	c,d,e,f=0,1,2,3
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	if data.findEdges(data.verts[vsel[c]],data.verts[vsel[d]])==None:
		c,d,e,f=1,2,3,0
	p1=Vector(msel[c][0],msel[c][1],msel[c][2])
	p2=Vector(msel[d][0],msel[d][1],msel[d][2])
	p3=Vector(msel[e][0],msel[e][1],msel[e][2])
	p4=Vector(msel[f][0],msel[f][1],msel[f][2])
	g=LineIntersect(p1,p2,p3,p4)
	matr[0]=Vector([msel[c][0]-g[0][0],msel[c][1]-g[0][1],msel[c][2]-g[0][2]]).length
	matr[1]=Vector([msel[d][0]-g[0][0],msel[d][1]-g[0][1],msel[d][2]-g[0][2]]).length
	matr[2]=Vector([msel[e][0]-g[0][0],msel[e][1]-g[0][1],msel[e][2]-g[0][2]]).length
	matr[3]=Vector([msel[f][0]-g[0][0],msel[f][1]-g[0][1],msel[f][2]-g[0][2]]).length
	# cerca la distanza minore
	if matr[0]<=matr[1] :
		vsel[d]=vsel[c]
	if matr[2]<=matr[3] :
		vsel[f]=vsel[e]
	if togscegli.val:
		data.verts.extend(g[0])
		data.edges.extend(data.verts[vsel[d]],data.verts[-1])
		data.edges.extend(data.verts[vsel[f]],data.verts[-1])
	else:
		data.verts[vsel[d]].co[0],data.verts[vsel[d]].co[1],data.verts[vsel[d]].co[2]=g[0][0],g[0][1],g[0][2]
		data.verts[vsel[f]].co[0],data.verts[vsel[f]].co[1],data.verts[vsel[f]].co[2]=g[0][0],g[0][1],g[0][2]
		# remdoubles
		if togrem.val:
			data.remDoubles(limita.val)
 	esce()
	Blender.Redraw()
		
def arrotondare():
	memorsel()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	raggio=rico[5]
	spicchi=rico[4]
	if vsel[3]==vsel[1]:
		c,e,d=2,3,0
	elif vsel[2]==vsel[1]:
		c,e,d=3,2,0
	elif vsel[0]==vsel[3]:
		c,e,d=2,3,1
	elif vsel[0]==vsel[2]:
		c,e,d=3,2,1
	#trasform
	cc=trasform(obj,msel[c])
	dd=trasform(obj,msel[d])
	ee=trasform(obj,msel[e])
	# calcola
	vec1=Vector(dd[0]-ee[0],dd[1]-ee[1],0)
	vec2=Vector(cc[0]-ee[0],cc[1]-ee[1],0)
	gamma=radians(AngleBetweenVecs(vec1,vec2))
	if gamma==0.0:
		gamma = radians(90)
	# Punti 1-V
	distazimut(cc[0],cc[1],ee[0],ee[1])
	d1v=diaz[0]
	teta1v=diaz[1]
	# calcolo
	alfa=radians(90)-gamma/2
	drv=raggio*sin(alfa)/sin(gamma/2)
	xx1=cc[0]+sin(radians(teta1v))*(d1v-drv)
	yy1=cc[1]+cos(radians(teta1v))*(d1v-drv)
	zz1=cc[2]	
	xc=xx1+sin(radians(teta1v+90))*raggio
	yc=yy1+cos(radians(teta1v+90))*raggio
	zp=zz1
	# disegna arco
	angarco=alfa*2/spicchi
	tetaab=radians(teta1v+90+180)
	for s in range (0,(spicchi)):
		xp=xc+raggio*sin(tetaab+(angarco*(s+1)))
		yp=yc+raggio*cos(tetaab+(angarco*(s+1)))
		if s==0:
			data.verts.extend(xx1,yy1,zz1)
		data.verts.extend(xp,yp,zp)
		data.edges.extend(data.verts[-1],data.verts[-2])
	data.edges.extend(data.verts[-1],data.verts[vsel[d]])
	data.edges.extend(data.verts[-(spicchi+1)],data.verts[vsel[c]])
	data.verts.delete(vsel[e])
	#trasform2
	for s in range (1,(spicchi+2)):
		data.verts[-s].co=trasform2(obj,data.verts[-s].co)
 	esce()
	Blender.Redraw()
	
def cerchio3p(ango,nn):
	memorsel()
	e,d,c=0,1,2
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	oggettoMatrix=obj.mat
	# trasform
	cc=trasform(obj,msel[c])
	dd=trasform(obj,msel[d])
	ee=trasform(obj,msel[e])
	# fine
	distazimut(cc[0],cc[1],ee[0],ee[1])
	teta1v=diaz[1]
	distazimut(cc[0],cc[1],dd[0],dd[1])
	teta2v=diaz[1]
	p1=Vector(cc[0],cc[1],0)
	p2=Vector(dd[0],dd[1],0)
	p3=Vector(ee[0],ee[1],0)
	vv1=MidpointVecs(p1,p2)
	vv2=MidpointVecs(p1,p3)
	teta2v+=90.0
	teta1v+=90.0
	if teta2v>360.0:teta2v-=360.0
	if teta1v>360.0:teta1v-=360.0
	xcd=vv1[0]+(1.0*sin(radians(teta2v)))
	ycd=vv1[1]+(1.0*cos(radians(teta2v)))
	zcd=vv1[2]
	xce=vv2[0]+(1.0*sin(radians(teta1v)))
	yce=vv2[1]+(1.0*cos(radians(teta1v)))
	zce=vv2[2]
	p1p=Vector(xcd,ycd,0)
	p2p=Vector(xce,yce,0)
	g=LineIntersect(vv1,p1p,vv2,p2p)
	raggio=Vector([cc[0]-g[0][0],cc[1]-g[0][1],0]).length
	rico[6]=raggio
	spicchi=rico[0]
	# calcolo angolo al centro
	Vettore1=Vector([cc[0]-g[0][0],cc[1]-g[0][1],0])
	Vettore2=Vector([dd[0]-g[0][0],dd[1]-g[0][1],0])
	Vettore3=Vector([ee[0]-g[0][0],ee[1]-g[0][1],0])
	alfa1=AngleBetweenVecs(Vettore1,Vettore2)
	alfa2=AngleBetweenVecs(Vettore2,Vettore3)
	alfa=AngleBetweenVecs(Vettore1,Vettore3)
	if ango==0.0:
		ango=alfa
		if (alfa1+alfa2)>(alfa+0.001):
			ango=360.0-ango
	if nn==1:# calcolo del solo centro
		gg=Vector(g[0][0],g[0][1],cc[2])
		centrofinale=trasform2(obj,gg)
		centro=trasforma(centrofinale,oggettoMatrix)
		memcursore(centro[0],centro[1],centro[2])
		esce()
		return
	if tog3.val:
		data.verts.extend(cc[0],cc[1],cc[2])
	cerchio(obj,data,g[0][0],g[0][1],g[0][2],raggio,spicchi,cc[0],cc[1],cc[2],ango)
	# remdoubles
	if togrem.val:
		data.remDoubles(limita.val)
 	esce()
	Blender.Redraw()

def cerchiodiam(n,testo,ango):
	if n==10:
		creavertice()
	memorsel()
	d,c=0,1
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	# trasf
	cc=trasform(obj,msel[c])
	dd=trasform(obj,msel[d])
	# fine
	distazimut(cc[0],cc[1],dd[0],dd[1])
	teta2v=diaz[1]
	d2v=diaz[0]
	if n==1:
		p1=Vector(cc[0],cc[1],0)
		p2=Vector(dd[0],dd[1],0)
		vv1=MidpointVecs(p1,p2)
		raggio=Vector([cc[0]-vv1[0],cc[1]-vv1[1],0]).length
	elif n==2:
		raggio=Vector([cc[0]-dd[0],cc[1]-dd[1],0]).length
	elif n==3 or n==6:
		raggio=rico[12]
	elif n==4 or n==5:
		raggio=rico[12]
		angini=rico[13]
	elif n==7 or n==8:
		if n==7:
			area=rico[22]
		elif n==8:
			perimetro=rico[23]
		angini=rico[13]
		if n==7:
			raggio=4.0*sqrt((area*360.0/ango)/pi) #correzione di n passato come valore
		elif n==8:
			raggio=5.0*(((perimetro*360.0/ango)/pi)/2) #correzione di n passato come valore
	elif n==10:#ex arcocursel poi passa a n=2
		data.verts.delete(data.verts[-1].index)
		raggio=Vector([cc[0]-dd[0],cc[1]-dd[1],0]).length
		n=2	
	spicchi=rico[0]
	if n==9:#lato poligono poi passa a n=4
		angini=rico[13]
		alfa=rico[14]/spicchi
		beta=(180.0-alfa)/2
		raggio=nrico[1]*sin(radians(beta))/sin(radians(alfa))
		tog3.val=1
		n=4
	if n==1 or n==2 or n==3 or n==6:
		if tog3.val:
			data.verts.extend(cc[0],cc[1],cc[2])
	else:
		raggio=raggio/(n-3)
		if tog3.val==0:
			raggio=raggio/sin(radians(90-(ango/(spicchi*2))))
			tog3.val=1
		x1p=dd[0]+raggio*sin(radians(angini)+obj.RotZ)
		y1p=dd[1]+raggio*cos(radians(angini)+obj.RotZ)
		data.verts.extend(x1p,y1p,dd[2])
		cerchio(obj,data,dd[0],dd[1],dd[2],raggio,spicchi,x1p,y1p,dd[2],ango)
	if n==1:
		cerchio(obj,data,vv1[0],vv1[1],vv1[2],raggio,spicchi,cc[0],cc[1],cc[2],ango)
	elif n==2:
		cerchio(obj,data,dd[0],dd[1],dd[2],raggio,spicchi,cc[0],cc[1],cc[2],ango)
	elif n==3 or n==6:
		if raggio < (d2v/2):
			PupMenu("Error%t|Radius minimum="+str(d2v/2))
  			rico[12]=d2v/2		
			data.verts.delete(data.verts[-1].index)
			esce()
			return
		else:	
			if tog2.val and n==3:teta=radians(teta2v)-acos((d2v/2)/raggio)
			else:teta=radians(teta2v)+acos((d2v/2)/raggio)
		xcc=cc[0]+raggio*sin(teta)
		ycc=cc[1]+raggio*cos(teta)
		if n==3:
			cerchio(obj,data,xcc,ycc,dd[2],raggio,spicchi,cc[0],cc[1],cc[2],ango)
		elif n==6:
			vec1=Vector([cc[0]-xcc,cc[1]-ycc])
			vec2=Vector([dd[0]-xcc,dd[1]-ycc])
			ango=AngleBetweenVecs(vec1,vec2)
			cerchio(obj,data,xcc,ycc,dd[2],raggio,spicchi,cc[0],cc[1],cc[2],ango)
	# remdoubles
	if togrem.val:
		for x in range(0,(len(data.verts))):
			data.verts[x].sel=1
		data.remDoubles(limita.val)
		for x in range(0,(len(data.verts))):
			data.verts[x].sel=0
		data.verts[-1].sel=1
 	esce()
	Blender.Redraw()
	
def arco2():
	global ricorda
	ango=0.0
	memorsel()
	d,c=0,1
	se=0
	creavertice()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	# trasf
	cc=trasform(obj,msel[c])
	dd=trasform(obj,msel[d])
	verti=trasform(obj,data.verts[-1].co)
	# fine
	data.verts.delete(data.verts[-1].index)
	raggio=Vector([cc[0]-verti[0],cc[1]-verti[1],0]).length
	spicchi=rico[0]
	if tog3.val:
		data.verts.extend(cc[0],cc[1],cc[2])
	vec1=Vector([cc[0]-verti[0],cc[1]-verti[1]])
	vec2=Vector([dd[0]-verti[0],dd[1]-verti[1]])
	ango=AngleBetweenVecs(vec1,vec2)
	if tog2.val:
		ango=360-ango
	cerchio(obj,data,verti[0],verti[1],verti[2],raggio,spicchi,cc[0],cc[1],cc[2],ango)
	# remdoubles
	if togrem.val:
		for x in range(0,(len(data.verts))):
			data.verts[x].sel=1
		data.remDoubles(limita.val)
		for x in range(0,(len(data.verts))):
			data.verts[x].sel=0
		data.verts[-1].sel=1
	esce()
	ricorda=raggio
	return ricorda
	Blender.Redraw()
	
def figure(n):
	global ricorda
	memorsel()
	d=0
	base=PupFloatInput("Base=",rico[15],-1000.0,1000.0,100,3)
	if base==None:
		PupMenu("Error%t|Insert a base")
		return
	rico[15]=base
	altez=PupFloatInput("Height=",rico[16],-1000.0,1000.0,100,3)
	if altez==None:
		PupMenu("Error%t|Insert an height")
		return
	rico[16]=altez
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	if n==1:
		v=[(msel[d][0]+base,msel[d][1],msel[d][2]),(msel[d][0]+base,msel[d][1]+altez,msel[d][2]),(msel[d][0],msel[d][1]+altez,msel[d][2])]
		data.verts.extend(v)
		data.edges.extend(data.verts[-1],data.verts[-2],data.verts[-3],data.verts[vsel[d]])
		ricorda=base*altez
	if n==2:
		basemin=PupFloatInput("Base min=",rico[17],-1000.0,1000.0,100,3)
		if basemin==None:
			PupMenu("Error%t|Insert a minor base")
			esce()
			return
		rico[17]=basemin
		v=[(msel[d][0]+base,msel[d][1],msel[d][2]),(msel[d][0]+basemin,msel[d][1]+altez,msel[d][2]),(msel[d][0],msel[d][1]+altez,msel[d][2])]
		data.verts.extend(v)
		data.edges.extend(data.verts[-1],data.verts[-2],data.verts[-3],data.verts[vsel[d]])
		ricorda=(base+basemin)*altez/2
	if n==3:
		basemin=PupFloatInput("Base min=",rico[17],-1000.0,1000.0,100,3)
		if basemin==None:
			PupMenu("Error%t|Insert a minor base")
			esce()
			return
		rico[17]=basemin
		v=[(msel[d][0]+base,msel[d][1],msel[d][2]),(msel[d][0]+basemin+(base-basemin)/2,msel[d][1]+altez,msel[d][2]),(msel[d][0]+(base-basemin)/2,msel[d][1]+altez,msel[d][2])]
		data.verts.extend(v)
		data.edges.extend(data.verts[-1],data.verts[-2],data.verts[-3],data.verts[vsel[d]])
		ricorda=(base+basemin)*altez/2
	if n==4:
		v=[(msel[d][0]+(base/2),msel[d][1],msel[d][2]),(msel[d][0],msel[d][1]+(altez/2),msel[d][2]),(msel[d][0]-(base/2),msel[d][1],msel[d][2]),(msel[d][0],msel[d][1]-(altez/2),msel[d][2])]
		data.verts.extend(v)
		data.edges.extend(data.verts[-1],data.verts[-2],data.verts[-3],data.verts[-4])
		ricorda=base*altez/2
	if n==5:
		v=[(msel[d][0]+base,msel[d][1],msel[d][2]),(msel[d][0],msel[d][1]+altez,msel[d][2])]
		data.verts.extend(v)
		data.edges.extend(data.verts[-1],data.verts[-2],data.verts[vsel[d]])
		ricorda=base*altez/2
	if n==6:
		v=[(msel[d][0]+base,msel[d][1],msel[d][2]),(msel[d][0]+(base/2),msel[d][1]+altez,msel[d][2])]
		data.verts.extend(v)
		data.edges.extend(data.verts[-1],data.verts[-2],data.verts[vsel[d]])
		ricorda=base*altez/2
 	esce()
	return ricorda
	Blender.Redraw()
	
def parallela(modo,cx1,cy1,cz1,cx2,cy2,cz2):
	global ricorda
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	xxyyzzc=cursoreinvista()
	# 1 sola linea
	if modo==1:
		vertici=data.verts.selected()
		if len(vertici)!=2 :
			PupMenu("Error%t|Insert only 2 points")
			esce()
			Blender.Redraw()
			return
		xyzc=trasform(obj,data.verts[vertici[0]].co)
		xyzp=trasform(obj,data.verts[vertici[1]].co)
		if xyzc==xyzp:
			PupMenu("Error%t|Insert 2 different points")
			esce()
			Blender.Redraw()
			return
		xc,yc,zc=xyzc[0],xyzc[1],xyzc[2]
		xp1,yp1,zp1=xyzp[0],xyzp[1],xyzp[2]
	# modo 1 fine	
	if modo==0:
		xc,yc,zc=cx1,cy1,cz1
		xp1,yp1,zp1=cx2,cy2,cz2
		dist2=rico[1]
	if yc==yp1 :
		if xp1>xc :
			tetaab=radians(90)
			raggio=(xc-xp1)/sin(tetaab)
		else :
			tetaab=radians(270)
			raggio=(xc-xp1)/sin(tetaab)	
	else :
		tetaab=atan((xc-xp1)/(yc-yp1))
		raggio=(yc-yp1)/cos(tetaab)
	if modo==1:
		dist2=rico[1]
	xp2=xc+dist2*sin(tetaab-radians(90))
	yp2=yc+dist2*cos(tetaab-radians(90))
	xp3=xp1+dist2*sin(tetaab-radians(90))
	yp3=yp1+dist2*cos(tetaab-radians(90))
	if Vector([xp2-xxyyzzc[0],yp2-xxyyzzc[1]]).length > Vector([xc-xxyyzzc[0],yc-xxyyzzc[1]]).length :
		xp2=xc+(dist2*-1)*sin(tetaab-radians(90))
		yp2=yc+(dist2*-1)*cos(tetaab-radians(90))
		xp3=xp1+(dist2*-1)*sin(tetaab-radians(90))
		yp3=yp1+(dist2*-1)*cos(tetaab-radians(90))
	zp2=zc+nrico[7]
	zp3=zp1+nrico[7]
	data.verts.extend(xp2,yp2,zp2)
	data.verts.extend(xp3,yp3,zp3)
	data.edges.extend(data.verts[-1],data.verts[-2])
	data.verts[-1].co=trasform2(obj,data.verts[-1].co)
	data.verts[-2].co=trasform2(obj,data.verts[-2].co)
	esce()
	ricorda=dist2
	return ricorda
	Blender.Redraw()

def muro(muro,pieno):
	flag=0
	liver=[]
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	e=me.edges.selected()
	v=me.verts.selected()
	#trasform
	for i in range (0,len(v)):
		me.verts[v[i]].co=trasform(obj,me.verts[v[i]].co)
	totv=len(me.verts)
	liver.append(me.verts[vsel[0]])
	for i in range (0,len(v)):
		ii=me.verts[v[i]].index
		try:
			find=me.findEdges(liver[0],me.verts[ii])
		except:
			PupMenu("Error%t|Insert the vertex of starting loop")
 			esce()
			return
		if find != None :
			if me.edges[find].sel ==1:
				edgefind=find
				liver.append(me.verts[ii])
				flag=1
			if flag==1:break
	flag=0
	for a in range (1,len(e)):
		for i in range (0,len(v)):
			ii=me.verts[v[i]].index
			try:
				find=me.findEdges(liver[a],me.verts[ii])
			except:
				PupMenu("Error%t|The sequence is not valid")
 				esce()
				return
			if find != None: 
				if find != edgefind:
					liver.append(me.verts[ii])
					vein,vece,veav=liver[a-1],liver[a],liver[a+1],
					distazimut(vece.co[0],vece.co[1],vein.co[0],vein.co[1])
					tetaind=radians(diaz[1])		
					distazimut(vece.co[0],vece.co[1],veav.co[0],veav.co[1])
					tetaava=radians(diaz[1])		
					if a==1:
						xpunto=vein.co[0]+muro*sin(tetaind-radians(90.0))
						ypunto=vein.co[1]+muro*cos(tetaind-radians(90.0))
						zpunto=vein.co[2]
						me.verts.extend(xpunto,ypunto,zpunto)
						il=me.verts[-1].index
						me.edges.extend(me.verts[-1],vein)
					if tetaind-tetaava>=0.0:
						tetaalfa=((tetaind-tetaava)/2)+tetaava
					elif tetaind-tetaava<=0.0:
						tetaalfa=(((tetaind-tetaava)/2)+tetaava)-radians(180.0)
					dpunto=muro/sin(tetaalfa-tetaava)
					xpunto=vece.co[0]+dpunto*sin(tetaalfa)
					ypunto=vece.co[1]+dpunto*cos(tetaalfa)
					zpunto=vece.co[2]
					me.verts.extend(xpunto,ypunto,zpunto)
					me.edges.extend(me.verts[-1],me.verts[-2])
					if pieno==1:me.faces.extend(me.verts[-1],me.verts[-2],vein,vece)
					if a==len(e)-1:
						xpunto=veav.co[0]+muro*sin(tetaava+radians(90.0))
						ypunto=veav.co[1]+muro*cos(tetaava+radians(90.0))
						zpunto=veav.co[2]
						me.verts.extend(xpunto,ypunto,zpunto)
						me.edges.extend(me.verts[-1],me.verts[-2])
						me.edges.extend(me.verts[-1],veav)
						if pieno==1:me.faces.extend(me.verts[-1],me.verts[-2],vece,veav)
					aaa=find
		edgefind=aaa
	#trasform2
	for i in range (0,len(v)):
		me.verts[v[i]].co=trasform2(obj,me.verts[v[i]].co)
	for i in range (1,len(v)):
		me.verts[-i].co=trasform2(obj,me.verts[-i].co)
	me.verts[il].co=trasform2(obj,me.verts[il].co)
	for i in range (1,len(v)+1):
		me.verts[-i].sel=0
	esce()
	Blender.Redraw()
	
def distanza(modo,lungh):
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	ve=data.verts.selected()
	for i in xrange (len(ve)):
		ver=data.verts[ve[i]]
		distazimut(msel[0][0],msel[0][1],ver.co[0],ver.co[1])
		if modo==4 or modo==5:
			distazimut(msel[0][0],msel[0][1],msel[1][0],msel[1][1])
			dist3d=sqrt(pow((msel[1][2]-msel[0][2]),2)+pow(diaz[0],2))
			lpiana=lungh*diaz[0]/dist3d
			x2=msel[0][0]+(lpiana*(msel[1][0]-msel[0][0])/diaz[0])
			y2=msel[0][1]+(lpiana*(msel[1][1]-msel[0][1])/diaz[0])
			z2=msel[0][2]+(lungh*(msel[1][2]-msel[0][2])/dist3d)
		elif modo==6 or modo==7:
			distazimut(msel[0][0],msel[0][1],msel[1][0],msel[1][1])
			dist3d=sqrt(pow((msel[1][2]-msel[0][2]),2)+pow(diaz[0],2))
			lpiana=(lungh+dist3d)*diaz[0]/dist3d
			x2=msel[0][0]+(lpiana*(msel[1][0]-msel[0][0])/diaz[0])
			y2=msel[0][1]+(lpiana*(msel[1][1]-msel[0][1])/diaz[0])
			z2=msel[0][2]+((lungh+dist3d)*(msel[1][2]-msel[0][2])/dist3d)
		if modo==0 or modo==1:
			dist3d=sqrt(pow((ver.co[2]-msel[0][2]),2)+pow(diaz[0],2))
			lpiana=lungh*diaz[0]/dist3d
			a=msel[0][0]+(lpiana*(ver.co[0]-msel[0][0])/diaz[0])
			b=msel[0][1]+(lpiana*(ver.co[1]-msel[0][1])/diaz[0])
			c=msel[0][2]+(lungh*(ver.co[2]-msel[0][2])/dist3d)
			if modo==0:
				ver.co[0]=a
				ver.co[1]=b
				ver.co[2]=c
			elif modo==1:
				data.verts.extend(a,b,c)
		elif modo==2 or modo==3:
			dist3d=sqrt(pow((ver.co[2]-msel[0][2]),2)+pow(diaz[0],2))
			lpiana=(lungh+dist3d)*diaz[0]/dist3d
			a=msel[0][0]+(lpiana*(ver.co[0]-msel[0][0])/diaz[0])
			b=msel[0][1]+(lpiana*(ver.co[1]-msel[0][1])/diaz[0])
			c=msel[0][2]+((lungh+dist3d)*(ver.co[2]-msel[0][2])/dist3d)
			if modo==2:
				ver.co[0]=a
				ver.co[1]=b
				ver.co[2]=c
			elif modo==3:
				data.verts.extend(a,b,c)
		elif modo==4 or modo==6:
			dx=x2-msel[1][0]
			dy=y2-msel[1][1]
			dz=z2-msel[1][2]
			ver.co[0]+=dx
			ver.co[1]+=dy
			ver.co[2]+=dz
		elif modo==5 or modo==7:
			dx=x2-msel[1][0]
			dy=y2-msel[1][1]
			dz=z2-msel[1][2]
			data.verts.extend(ver.co[0]+dx,ver.co[1]+dy,ver.co[2]+dz)
	esce()
	Blender.Redraw()
	
def congiungi():
	memorsel()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	#trasform
	con2=trasform(obj,msel[2])
	con3=trasform(obj,msel[3])
	con0=trasform(obj,msel[0])
	con1=trasform(obj,msel[1])
	p1=Vector(con2[0],con2[1],con2[2])
	p2=Vector(con3[0],con3[1],con3[2])
	p3=Vector(con0[0],con0[1],con0[2])
	p4=Vector(con1[0],con1[1],con1[2])
	g=LineIntersect(p1,p2,p3,p4)
	try:
		matr[0]=Vector([con0[0]-g[0][0],con0[1]-g[0][1],con0[2]-g[0][2]]).length
		matr[1]=Vector([con1[0]-g[0][0],con1[1]-g[0][1],con1[2]-g[0][2]]).length
	except:
		PupMenu("Error%t|Operation not allowed")
 		esce()
		return
	if matr[1]==matr[0] :
		PupMenu("Possible Error%t|Vertexes at the same distance")
	if togscegli.val:
		if matr[0]<matr[1] :
			data.verts.extend(g[0][0],g[0][1],g[0][2])
			data.edges.extend(data.verts[vsel[0]],data.verts[-1])
		if matr[1]<matr[0] :
			data.verts.extend(g[0][0],g[0][1],g[0][2])
			data.edges.extend(data.verts[vsel[1]],data.verts[-1])
		data.verts[-1].co=trasform2(obj,data.verts[-1].co)
	else:
		ggg=trasform2(obj,g[0])
		g[0][0],g[0][1],g[0][2]=ggg[0],ggg[1],ggg[2]
		if matr[0]<matr[1] :
			data.verts[vsel[0]].co=g[0]
		if matr[1]<matr[0] :
			data.verts[vsel[1]].co=g[0]
	#trasform2
 	msel[0],msel[1]=msel[2],msel[3]	
	Blender.s1=msel[0]
	Blender.s2=msel[1]
	esce()
	Blender.Redraw()
		
def quotah(qu):
	valqu=1.0
	cc=cursoreinvista()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	ver=me.verts.selected()
	if len(ver)<2 or len(ver)>2 :PupMenu("Error%t|Select only 2 vertexes");esce();return
	# trasform
	v0=trasform(obj,me.verts[ver[0]].co)
	v1=trasform(obj,me.verts[ver[1]].co)
	# inizio
	scn=Blender.Scene.GetCurrent()
	obj2 = Object.New('Mesh')
	scn.link(obj2)
	obj2.setMatrix(obj.mat)
	mes=obj2.getData(mesh=1)
	if qu==2:valqu=0.0
	mes.verts.extend(v0[0],cc[1],v0[2]*valqu)
	mes.verts.extend(v1[0],cc[1],v1[2]*valqu)
	valtesto=(Vector([v0[0]-v1[0],cc[1]-cc[1],v0[2]*valqu-v1[2]*valqu]).length)
	valtesto*=riquote[6]
	valtesto=str(arrot(valtesto))
	textce=[0.0,0.0,0.0]
	textce[0]=(v0[0]+v1[0])/2
	textce[1]=cc[1]+riquote[3]
	textce[2]=((v0[2]+v1[2])/2)*valqu
	mes.edges.extend(mes.verts[0],mes.verts[1])
	if v0[1] > cc[1] and v1[1] > cc[1]:
		mes.verts.extend(v0[0],v0[1]-riquote[1],v0[2]*valqu)
		mes.verts.extend(v1[0],v1[1]-riquote[1],v1[2]*valqu)
	else :
		mes.verts.extend(v0[0],v0[1]+riquote[1],v0[2]*valqu)
		mes.verts.extend(v1[0],v1[1]+riquote[1],v1[2]*valqu)
	mes.edges.extend(mes.verts[0],mes.verts[2])
	mes.edges.extend(mes.verts[1],mes.verts[3])
	mes.verts.extend(mes.verts[0].co[0]+(0.1*riquote[2]),mes.verts[0].co[1]+(0.1*riquote[2]),mes.verts[0].co[2])
	mes.verts.extend(mes.verts[0].co[0]-(0.1*riquote[2]),mes.verts[0].co[1]-(0.1*riquote[2]),mes.verts[0].co[2])
	mes.edges.extend(mes.verts[4],mes.verts[0])
	mes.edges.extend(mes.verts[5],mes.verts[0])
	mes.verts.extend(mes.verts[1].co[0]+(0.1*riquote[2]),mes.verts[1].co[1]+(0.1*riquote[2]),mes.verts[1].co[2])
	mes.verts.extend(mes.verts[1].co[0]-(0.1*riquote[2]),mes.verts[1].co[1]-(0.1*riquote[2]),mes.verts[1].co[2])
	mes.edges.extend(mes.verts[6],mes.verts[1])
	mes.edges.extend(mes.verts[7],mes.verts[1])
	if v0[1] > cc[1] and v1[1] > cc[1]:
		mes.verts.extend(mes.verts[0].co[0],mes.verts[0].co[1]-(0.1*riquote[2]),mes.verts[0].co[2])
		mes.verts.extend(mes.verts[1].co[0],mes.verts[1].co[1]-(0.1*riquote[2]),mes.verts[1].co[2])
	else:	
		mes.verts.extend(mes.verts[0].co[0],mes.verts[0].co[1]+(0.1*riquote[2]),mes.verts[0].co[2])
		mes.verts.extend(mes.verts[1].co[0],mes.verts[1].co[1]+(0.1*riquote[2]),mes.verts[1].co[2])
	mes.edges.extend(mes.verts[8],mes.verts[0])
	mes.edges.extend(mes.verts[9],mes.verts[1])
	# scrivi testo
	txt=Text3d.New("Quota")
	ob=scn.objects.new(txt)
	txt.setText(valtesto+" "+riquote[-1])
	txt.setAlignment(Text3d.MIDDLE)
	txt.setSize(riquote[0])
	# trasform2
	textce=trasform2(ob,Vector(textce))
	for i in range (0,10):
		mes.verts[i].co=trasform2(obj,mes.verts[i].co)
	# allinea testo alla vista
	matr=Window.GetViewMatrix()
	ob.setMatrix(matr.invert())
	# sistema posizione testo
	ob.setLocation(textce)
	obj2.setName("Quota")
	obj2.select(0)
	ob.select(0)
	obj.select(1)
	ob.Layer=riquote[4]
	obj2.Layer=riquote[4]
	esce()
	Blender.Redraw()

def quotav(qu):
	valqu=1.0
	cc=cursoreinvista()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Errore%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	ver=me.verts.selected()
	if len(ver)<2 or len(ver)>2 :PupMenu("Error%t|Select only 2 vertexes");esce();return
	# trasform
	v0=trasform(obj,me.verts[ver[0]].co)
	v1=trasform(obj,me.verts[ver[1]].co)
	# inizio
	scn=Blender.Scene.GetCurrent()
	obj2 = Object.New('Mesh')
	scn.link(obj2)
	obj2.setMatrix(obj.mat)
	mes=obj2.getData(mesh=1)
	if qu==2:valqu=0.0
	mes.verts.extend(cc[0],v0[1],v0[2]*valqu)
	mes.verts.extend(cc[0],v1[1],v1[2]*valqu)
	valtesto=(Vector([cc[0]-cc[0],v0[1]-v1[1],v0[2]*valqu-v1[2]*valqu]).length)
	valtesto*=riquote[6]
	valtesto=str(arrot(valtesto))
	textce=[0.0,0.0,0.0]
	textce[0]=cc[0]-riquote[3]
	textce[1]=(v0[1]+v1[1])/2
	textce[2]=((v0[2]+v1[2])/2)*valqu
	mes.edges.extend(mes.verts[0],mes.verts[1])
	if v0[0] > cc[0] and v1[0] > cc[0]:
		mes.verts.extend(v0[0]-riquote[1],v0[1],v0[2]*valqu)
		mes.verts.extend(v1[0]-riquote[1],v1[1],v1[2]*valqu)
	else :
		mes.verts.extend(v0[0]+riquote[1],v0[1],v0[2]*valqu)
		mes.verts.extend(v1[0]+riquote[1],v1[1],v1[2]*valqu)
	mes.edges.extend(mes.verts[0],mes.verts[2])
	mes.edges.extend(mes.verts[1],mes.verts[3])
	mes.verts.extend(mes.verts[0].co[0]+(0.1*riquote[2]),mes.verts[0].co[1]+(0.1*riquote[2]),mes.verts[0].co[2])
	mes.verts.extend(mes.verts[0].co[0]-(0.1*riquote[2]),mes.verts[0].co[1]-(0.1*riquote[2]),mes.verts[0].co[2])
	mes.edges.extend(mes.verts[4],mes.verts[0])
	mes.edges.extend(mes.verts[5],mes.verts[0])
	mes.verts.extend(mes.verts[1].co[0]+(0.1*riquote[2]),mes.verts[1].co[1]+(0.1*riquote[2]),mes.verts[1].co[2])
	mes.verts.extend(mes.verts[1].co[0]-(0.1*riquote[2]),mes.verts[1].co[1]-(0.1*riquote[2]),mes.verts[1].co[2])
	mes.edges.extend(mes.verts[6],mes.verts[1])
	mes.edges.extend(mes.verts[7],mes.verts[1])
	if v0[0] > cc[0] and v1[0] > cc[0]:
		mes.verts.extend(mes.verts[0].co[0]-(0.1*riquote[2]),mes.verts[0].co[1],mes.verts[0].co[2])
		mes.verts.extend(mes.verts[1].co[0]-(0.1*riquote[2]),mes.verts[1].co[1],mes.verts[1].co[2])
	else:
		mes.verts.extend(mes.verts[0].co[0]+(0.1*riquote[2]),mes.verts[0].co[1],mes.verts[0].co[2])
		mes.verts.extend(mes.verts[1].co[0]+(0.1*riquote[2]),mes.verts[1].co[1],mes.verts[1].co[2])
	mes.edges.extend(mes.verts[8],mes.verts[0])
	mes.edges.extend(mes.verts[9],mes.verts[1])
	# scrivi testo
	txt=Text3d.New("Quota")
	ob=scn.objects.new(txt)
	txt.setText(valtesto+" "+riquote[-1])
	txt.setAlignment(Text3d.MIDDLE)
	txt.setSize(riquote[0])
	# trasform2
	textce=trasform2(ob,Vector(textce))
	for i in range (0,10):
		mes.verts[i].co=trasform2(obj,mes.verts[i].co)
	if riquote[5]==0:
		# allinea testo alla vista
		matr=Window.GetViewMatrix()
		m2=matr.invert()
		m3=m2.toEuler()
		RotateEuler(m3,90,"z")
		m2=m3.toMatrix()
		ob.setMatrix(m2)
	else:
		# allinea testo alla vista
		matr=Window.GetViewMatrix()
		ob.setMatrix(matr.invert())
	# sistema posizione testo
	ob.setLocation(textce)
	obj2.setName("Quota")
	obj2.select(0)
	ob.select(0)
	obj.select(1)
	ob.Layer=riquote[4]
	obj2.Layer=riquote[4]
	esce()
	Blender.Redraw()

def quotao(qu):
	valqu=1.0
	cc=cursoreinvista()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	ver=me.verts.selected()
	if len(ver)<2 or len(ver)>2 :PupMenu("Error%t|Select only 2 vertexes");esce();return
	# trasform
	v0=trasform(obj,me.verts[ver[0]].co)
	v1=trasform(obj,me.verts[ver[1]].co)
	xc,yc,zc=v0[0],v0[1],v0[2]
	xp1,yp1,zp1=v1[0],v1[1],v1[2]
	xxc,yyc,zzc=cc[0],cc[1],cc[2]
	# inizio
	scn=Blender.Scene.GetCurrent()
	obj2 = Object.New('Mesh')
	scn.link(obj2)
	obj2.setMatrix(obj.mat)
	mes=obj2.getData(mesh=1)
	if qu==2:valqu=0.0
	if xc==xp1 and yc==yp1 and zc==zp1:
		PupMenu("Error%t|Insert 2 different points")
		esce()
		Blender.Redraw()
		return
	if yc==yp1 :
		if xp1>xc :
			tetaab=radians(90)
			raggio=(xc-xp1)/sin(tetaab)
		else :
			tetaab=radians(270)
			raggio=(xc-xp1)/sin(tetaab)	
	else :
		tetaab=atan((xc-xp1)/(yc-yp1))
		raggio=(yc-yp1)/cos(tetaab)
	# calcola distanza dal cursore
	vetto1=Vector([xxc-xp1,yyc-yp1,0])
	vetto2=Vector([xc-xp1,yc-yp1,0])
	ang=AngleBetweenVecs(vetto1,vetto2)
	distazimut(xp1,yp1,xxc,yyc)
	d2=diaz[0]
	dist2=d2*sin(radians(ang))
	#
	xp2=xc+dist2*sin(tetaab-radians(90))
	yp2=yc+dist2*cos(tetaab-radians(90))
	xp3=xp1+dist2*sin(tetaab-radians(90))
	yp3=yp1+dist2*cos(tetaab-radians(90))
	if Vector([xp2-xxc,yp2-yyc]).length > Vector([xc-xxc,yc-yyc]).length :
		xp2=xc+(dist2*-1)*sin(tetaab-radians(90))
		yp2=yc+(dist2*-1)*cos(tetaab-radians(90))
		xp3=xp1+(dist2*-1)*sin(tetaab-radians(90))
		yp3=yp1+(dist2*-1)*cos(tetaab-radians(90))
	zp2=zc
	zp3=zp1
	mes.verts.extend(xp2,yp2,zp2*valqu)
	mes.verts.extend(xp3,yp3,zp3*valqu)
	valtesto=(Vector([xp2-xp3,yp2-yp3,zp2*valqu-zp3*valqu]).length)
	valtesto*=riquote[6]
	valtesto=str(arrot(valtesto))
	textce=[0.0,0.0,0.0]
	textce[0]=(xp2+xp3)/2+(0.1*riquote[2])*sin(tetaab-radians(90))
	textce[1]=(yp2+yp3)/2+(0.1*riquote[2])*cos(tetaab-radians(90))
	textce[2]=((zp2+zp3)/2)*valqu
	mes.edges.extend(mes.verts[0],mes.verts[1])
	# crea vertici linee di quota
	xl1=xc+riquote[1]*sin(tetaab-radians(90))
	yl1=yc+riquote[1]*cos(tetaab-radians(90))
	if Vector([xl1-xxc,yl1-yyc]).length > Vector([xc-xxc,yc-yyc]).length :
		xl1=xc+(riquote[1]*-1)*sin(tetaab-radians(90))
		yl1=yc+(riquote[1]*-1)*cos(tetaab-radians(90))
		xl2=xp1+(riquote[1]*-1)*sin(tetaab-radians(90))
		yl2=yp1+(riquote[1]*-1)*cos(tetaab-radians(90))
		xl3=xp2+(-0.1*riquote[2])*sin(tetaab-radians(90))
		yl3=yp2+(-0.1*riquote[2])*cos(tetaab-radians(90))
		xl4=xp3+(-0.1*riquote[2])*sin(tetaab-radians(90))
		yl4=yp3+(-0.1*riquote[2])*cos(tetaab-radians(90))
	else:
		xl2=xp1+riquote[1]*sin(tetaab-radians(90))
		yl2=yp1+riquote[1]*cos(tetaab-radians(90))
		xl3=xp2+(0.1*riquote[2])*sin(tetaab-radians(90))
		yl3=yp2+(0.1*riquote[2])*cos(tetaab-radians(90))
		xl4=xp3+(0.1*riquote[2])*sin(tetaab-radians(90))
		yl4=yp3+(0.1*riquote[2])*cos(tetaab-radians(90))
	mes.verts.extend(xl1,yl1,zc*valqu)
	mes.edges.extend(mes.verts[-1],mes.verts[0])
	mes.verts.extend(xl2,yl2,zp1*valqu)
	mes.edges.extend(mes.verts[-1],mes.verts[1])
	mes.verts.extend(xl3,yl3,zp2*valqu)
	mes.edges.extend(mes.verts[-1],mes.verts[0])
	mes.verts.extend(xl4,yl4,zp3*valqu)
	mes.edges.extend(mes.verts[-1],mes.verts[1])
	mes.verts.extend(xp2+(0.1*sin(tetaab-radians(45))*riquote[2]),yp2+(0.1*cos(tetaab-radians(45))*riquote[2]),zp2*valqu)
	mes.verts.extend(xp2-(0.1*sin(tetaab-radians(45))*riquote[2]),yp2-(0.1*cos(tetaab-radians(45))*riquote[2]),zp2*valqu)
	mes.edges.extend(mes.verts[-1],mes.verts[0])
	mes.edges.extend(mes.verts[-2],mes.verts[0])
	mes.verts.extend(xp3+(0.1*sin(tetaab-radians(45))*riquote[2]),yp3+(0.1*cos(tetaab-radians(45))*riquote[2]),zp3*valqu)
	mes.verts.extend(xp3-(0.1*sin(tetaab-radians(45))*riquote[2]),yp3-(0.1*cos(tetaab-radians(45))*riquote[2]),zp3*valqu)
	mes.edges.extend(mes.verts[-1],mes.verts[1])
	mes.edges.extend(mes.verts[-2],mes.verts[1])
	# scrivi testo
	txt=Text3d.New("Quota")
	ob=scn.objects.new(txt)
  # ob.MakeDisplayList()
	txt.setText(valtesto+" "+riquote[-1])
	txt.setAlignment(Text3d.MIDDLE)
	txt.setSize(riquote[0])
	# trasform2
	textce=trasform2(ob,Vector(textce))
	for i in range (0,10):# n vertici nuovi
		mes.verts[i].co=trasform2(obj,mes.verts[i].co)
	if riquote[5]==0:
		# allinea testo ruotato alla vista
		matr=Window.GetViewMatrix()
		m2=matr.invert()
		m3=m2.toEuler()
		if degrees(tetaab) >= 180.0 and degrees(tetaab) <= 360.0:tetaab-=pi
		RotateEuler(m3,90-degrees(tetaab),"z")
		m2=m3.toMatrix()
		ob.setMatrix(m2)
	else:
		# allinea testo orizzontale alla vista
		matr=Window.GetViewMatrix()
		ob.setMatrix(matr.invert())
	# sistema posizione testo
	ob.setLocation(textce)
	obj2.setName("Quota")
	obj2.select(0)
	ob.select(0)
	obj.select(1)
	ob.Layer=riquote[4]
	obj2.Layer=riquote[4]
	esce()
	Blender.Redraw()

def indicazione():
	cc=cursoreinvista()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	ver=me.verts.selected()
	testo=PupStrInput("Text: ","",20)
	# trasform
	v0=trasform(obj,me.verts[ver[0]].co)
	# inizio
	scn=Blender.Scene.GetCurrent()
	obj2 = Object.New('Mesh')
	scn.link(obj2)
	obj2.setMatrix(obj.mat)
	mes=obj2.getData(mesh=1)
	distazimut(v0[0],v0[1],cc[0],cc[1])
	xi1=v0[0]+riquote[1]*sin(radians(diaz[1]))
	yi1=v0[1]+riquote[1]*cos(radians(diaz[1]))
	mes.verts.extend(xi1,yi1,v0[2])
	mes.verts.extend(cc[0],cc[1],v0[2])
	textce=[0.0,0.0,0.0]
	if v0[0]<cc[0]:
		textce[0]=cc[0]+riquote[3]+0.1*riquote[2]
		mes.verts.extend(cc[0]+riquote[3],cc[1],v0[2])
	else:
		textce[0]=cc[0]-riquote[3]-0.1*riquote[2]
		mes.verts.extend(cc[0]-riquote[3],cc[1],v0[2])
	textce[1]=cc[1]
	textce[2]=v0[2]
	mes.edges.extend(mes.verts[0],mes.verts[1])
	mes.edges.extend(mes.verts[1],mes.verts[2])
	xfr1=xi1+0.1*riquote[2]*sin(radians(diaz[1]+20.0))
	yfr1=yi1+0.1*riquote[2]*cos(radians(diaz[1]+20.0))
	xfr2=xi1+0.1*riquote[2]*sin(radians(diaz[1]-20.0))
	yfr2=yi1+0.1*riquote[2]*cos(radians(diaz[1]-20.0))
	mes.verts.extend(xfr1,yfr1,v0[2])
	mes.verts.extend(xfr2,yfr2,v0[2])
	mes.edges.extend(mes.verts[0],mes.verts[-1])
	mes.edges.extend(mes.verts[0],mes.verts[-2])
	# scrivi testo
	txt=Text3d.New("Quota")
	ob=scn.objects.new(txt)
	txt.setText(testo)
	if v0[0]<cc[0]:
		txt.setAlignment(Text3d.LEFT)
	else:
		txt.setAlignment(Text3d.RIGHT)
	txt.setSize(riquote[0])
	# trasform2
	textce=trasform2(ob,Vector(textce))
	for i in range (0,5):
		mes.verts[i].co=trasform2(obj,mes.verts[i].co)
	# allinea testo alla vista
	matr=Window.GetViewMatrix()
	ob.setMatrix(matr.invert())
	# sistema posizione testo
	ob.setLocation(textce)
	obj2.setName("Quota")
	obj2.select(0)
	ob.select(0)
	obj.select(1)
	ob.Layer=riquote[4]
	obj2.Layer=riquote[4]
	esce()
	Blender.Redraw()

def quotangolo(qu):
	cc=cursoreinvista()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	ver=me.verts.selected()
	# trasform
	ms0=trasform(obj,msel[0])
	ms1=trasform(obj,msel[1])
	v0=trasform(obj,me.verts[ver[0]].co)
	# inizio
	scn=Blender.Scene.GetCurrent()
	obj2 = Object.New('Mesh')
	scn.link(obj2)
	obj2.setMatrix(obj.mat)
	mes=obj2.getData(mesh=1)
	distazimut(v0[0],v0[1],cc[0],cc[1])
	raggioq=diaz[0]
	distazimut(v0[0],v0[1],ms1[0],ms1[1])
	tetaq=diaz[1]
	vec1=Vector(ms1[0]-v0[0],ms1[1]-v0[1],0)
	vec2=Vector(ms0[0]-v0[0],ms0[1]-v0[1],0)
	angoloq=AngleBetweenVecs(vec1,vec2)
	if qu==1:
		angoloq=360.0-angoloq
	testo=str(arrot(angoloq*riquote[8]))
	angoqq=0.0
	for i in range (0,20):
		xi1=v0[0]+raggioq*sin(radians(tetaq+angoqq))
		yi1=v0[1]+raggioq*cos(radians(tetaq+angoqq))
		mes.verts.extend(xi1,yi1,v0[2])
		angoqq+=angoloq/19
	for i in range (0,19):
		mes.edges.extend(mes.verts[i],mes.verts[i+1])
#   frecce
	xf1=mes.verts[0].co[0]+0.1*riquote[2]*sin(radians(tetaq+70.0))
	yf1=mes.verts[0].co[1]+0.1*riquote[2]*cos(radians(tetaq+70.0))
	xf2=mes.verts[0].co[0]+0.1*riquote[2]*sin(radians(tetaq+110.0))
	yf2=mes.verts[0].co[1]+0.1*riquote[2]*cos(radians(tetaq+110.0))
	mes.verts.extend(xf1,yf1,v0[2])
	mes.verts.extend(xf2,yf2,v0[2])
	mes.edges.extend(mes.verts[0],mes.verts[-1])
	mes.edges.extend(mes.verts[0],mes.verts[-2])
	xf3=mes.verts[19].co[0]+0.1*riquote[2]*sin(radians(tetaq+angoloq-70.0))
	yf3=mes.verts[19].co[1]+0.1*riquote[2]*cos(radians(tetaq+angoloq-70.0))
	xf4=mes.verts[19].co[0]+0.1*riquote[2]*sin(radians(tetaq+angoloq-110.0))
	yf4=mes.verts[19].co[1]+0.1*riquote[2]*cos(radians(tetaq+angoloq-110.0))
	mes.verts.extend(xf3,yf3,v0[2])
	mes.verts.extend(xf4,yf4,v0[2])
	mes.edges.extend(mes.verts[19],mes.verts[-1])
	mes.edges.extend(mes.verts[19],mes.verts[-2])
	if riquote[7] > 0:
		mes.verts.extend(v0[0],v0[1],v0[2])
		mes.edges.extend(mes.verts[19],mes.verts[-1])
		mes.edges.extend(mes.verts[0],mes.verts[-1])
#	testo
	textce=[0.0,0.0,0.0]
	textce[0]=cc[0]
	textce[1]=cc[1]+riquote[3]
	textce[2]=v0[2]
	# scrivi testo
	txt=Text3d.New("Quota")
	ob=scn.objects.new(txt)
	txt.setText(testo+" "+riquote[-2])
	txt.setAlignment(Text3d.MIDDLE)
	txt.setSize(riquote[0])
	# trasform2
	textce=trasform2(ob,Vector(textce))
	for i in range (0,24):
		mes.verts[i].co=trasform2(obj,mes.verts[i].co)
	if riquote[7] > 0:
		mes.verts[-1].co=trasform2(obj,mes.verts[-1].co)
	# allinea testo alla vista
	matr=Window.GetViewMatrix()
	ob.setMatrix(matr.invert())
	# sistema posizione testo
	ob.setLocation(textce)
	obj2.setName("Quota")
	obj2.select(0)
	ob.select(0)
	obj.select(1)
	ob.Layer=riquote[4]
	obj2.Layer=riquote[4]
	esce()
	Blender.Redraw()

def indicaraggio():
	cc=cursoreinvista()
	ccx,ccy,ccz=cc[0],cc[1],cc[2]
	cerchio3p(0.0,1)
	cc=cursoreinvista()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	ver=me.verts.selected()
	# trasform
	v0=trasform(obj,me.verts[ver[0]].co)
	# inizio
	scn=Blender.Scene.GetCurrent()
	obj2 = Object.New('Mesh')
	scn.link(obj2)
	obj2.setMatrix(obj.mat)
	mes=obj2.getData(mesh=1)
	rag=Vector([cc[0]-v0[0],cc[1]-v0[1],1-1]).length
	distazimut(cc[0],cc[1],ccx,ccy)
	d0=cc[0]+rag*sin(radians(diaz[1]))
	d1=cc[1]+rag*cos(radians(diaz[1]))
	mes.verts.extend(d0,d1,cc[2])
	mes.verts.extend(cc[0],cc[1],cc[2])
	mes.edges.extend(mes.verts[0],mes.verts[1])
	# frecce
	xi1=d0+0.1*riquote[2]*sin(radians(diaz[1]+160.0))
	yi1=d1+0.1*riquote[2]*cos(radians(diaz[1]+160.0))
	mes.verts.extend(xi1,yi1,cc[2])
	mes.edges.extend(mes.verts[0],mes.verts[-1])
	xi2=d0+0.1*riquote[2]*sin(radians(diaz[1]+200.0))
	yi2=d1+0.1*riquote[2]*cos(radians(diaz[1]+200.0))
	mes.verts.extend(xi2,yi2,cc[2])
	mes.edges.extend(mes.verts[0],mes.verts[-1])
	textce=[0.0,0.0,0.0]
	if ccx>cc[0]:
		textce[0]=ccx+riquote[3]+0.1*riquote[2]
	else:
		textce[0]=ccx-riquote[3]-0.1*riquote[2]
	textce[1]=ccy
	textce[2]=ccz
	# scrivi testo
	txt=Text3d.New("Quota")
	ob=scn.objects.new(txt)
	txt.setText("r "+str(arrot(rag*riquote[6])))
	if ccx>cc[0]:
		txt.setAlignment(Text3d.LEFT)
	else:
		txt.setAlignment(Text3d.RIGHT)
	txt.setSize(riquote[0])
	# trasform2
	textce=trasform2(ob,Vector(textce))
	for i in range (0,4):
		mes.verts[i].co=trasform2(obj,mes.verts[i].co)
	# allinea testo alla vista
	matr=Window.GetViewMatrix()
	ob.setMatrix(matr.invert())
	# sistema posizione testo
	ob.setLocation(textce)
	obj2.setName("Quota")
	obj2.select(0)
	ob.select(0)
	obj.select(1)
	ob.Layer=riquote[4]
	obj2.Layer=riquote[4]
	esce()
	Blender.Redraw()

def ellissi(n):
	memorsel()
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	data=obj.getData(mesh=1)
	a=1
	if tog4.val>0:
		a=-1
	ragmax,ragmin=rico[19],rico[20]
	spicchi=rico[0]
	angini=radians(rico[13])
	corz=(nrico[12]/rico[0])*nrico[13]
	nrico[13]=0
	# trasf
	ms0=trasform(obj,msel[0])
	ms1=trasform(obj,msel[1])
	if n==3 or n==4:
		distazimut(ms0[0],ms0[1],ms1[0],ms1[1])
		ragmax=diaz[0]
		angini=radians(360.0-(diaz[1]-90.0))
	ango=rico[21]/spicchi
	if n==2 or n==4:
		ragmax=ragmax/2
		ragmin=ragmin/2
	if n==4:
		p1=Vector(ms0[0],ms0[1],ms0[2])
		p2=Vector(ms1[0],ms1[1],ms1[2])
		vv1=MidpointVecs(p1,p2)
	if n==1 or n==2:
		xcen,ycen,zcen=ms0[0],ms0[1],ms0[2]
	elif n==3:
		xcen,ycen,zcen=ms0[0],ms0[1],ms1[2]
	elif n==4:
		xcen,ycen,zcen=vv1[0],vv1[1],ms1[2]
	xnp=ragmax*cos(0)
	ynp=ragmin*sin(0)
	xnp2=xcen+(xnp*cos(angini)-ynp*sin(angini))
	ynp2=ycen+(ynp*cos(angini)+xnp*sin(angini))
	data.verts.extend(xnp2,ynp2,zcen)
	for s in range (1,(spicchi+1)):
		xnp=ragmax*cos(radians(ango*s*a))
		ynp=ragmin*sin(radians(ango*s*a))
		xnp2=xcen+(xnp*cos(angini)-ynp*sin(angini))
		ynp2=ycen+(ynp*cos(angini)+xnp*sin(angini))
		data.verts.extend(xnp2,ynp2,zcen+(corz*s))
		data.edges.extend(data.verts[-2],data.verts[-1])
	if rico[21]>= 360.0:
		data.edges.extend(data.verts[-1],data.verts[-spicchi-1])
	for s in range (1,(spicchi+2)):
		data.verts[-s].co=trasform2(obj,data.verts[-s].co)
	# remdoubles
	if togrem.val:
		for x in range(0,(len(data.verts))):
			data.verts[x].sel=1
		data.remDoubles(limita.val)
		for x in range(0,(len(data.verts))):
			data.verts[x].sel=0
		data.verts[-1].sel=1
	esce()
	Blender.Redraw()

def taglia(n):
	memo=[]
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	e=me.edges.selected()
	t0=trasform(obj,msel[0])
	t1=trasform(obj,msel[1])
	for a in range (0,len(e)):
		vert1=me.edges[e[a]].v1
		vert2=me.edges[e[a]].v2
		vertice1=trasform(obj,vert1.co)
		vertice2=trasform(obj,vert2.co)
		p1=Vector(t0[0],t0[1],0)
		p2=Vector(t1[0],t1[1],0)
		p3=Vector(vertice1[0],vertice1[1],0)
		p4=Vector(vertice2[0],vertice2[1],0)
		g=LineIntersect(p1,p2,p3,p4)
		try:
			distot=Vector([vertice2[0]-vertice1[0],vertice2[1]-vertice1[1]]).length
			dist1=Vector([vertice1[0]-g[0][0],vertice1[1]-g[0][1]]).length
		except:
			PupMenu("Error%t|Cut line parrallel at selected one")
			esce()
			Blender.Redraw()
			return
		if distot==0.0:
			PupMenu("Error%t|Operation not allowed")
			esce()
			Blender.Redraw()
			return
		dz1=dist1*(vertice2[2]-vertice1[2])/distot
		vertok=g[0][0],g[0][1],vertice1[2]+dz1
		if ((vertice1[0]>=vertok[0] and vertok[0]>=vertice2[0]) or (vertice1[0]<=vertok[0] and vertok[0]<=vertice2[0])) and ((vertice1[1]>=vertok[1] and vertok[1]>=vertice2[1]) or (vertice1[1]<=vertok[1] and vertok[1]<=vertice2[1])):
			if ((t0[0]>=vertok[0] and vertok[0]>=t1[0]) or (t0[0]<=vertok[0] and vertok[0]<=t1[0])) and ((t0[1]>=vertok[1] and vertok[1]>=t1[1]) or (t0[1]<=vertok[1] and vertok[1]<=t1[1])):
				vertok=trasform2(obj,Vector(vertok))	
				me.verts.extend(vertok[0],vertok[1],vertok[2])
				memo.append(e[a])
	if n==2:
		for a in range (0,len(memo)):
			me.edges.extend(me.edges[memo[a]].v1,me.verts[-(len(memo)-a)])
			me.edges.extend(me.edges[memo[a]].v2,me.verts[-(len(memo)-a)])
		for a in range (0,len(memo)):
			me.edges.delete(me.edges[memo[a]-a])
	esce()
	
def muoviortovista():
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	ver=me.verts.selected()
	for a in range (0,len(ver)):
		vertice=trasform(obj,me.verts[ver[a]].co)
		vertice[0]+=nrico[14]
		vertice[1]+=nrico[15]
		vertice[2]+=nrico[16]
		me.verts[ver[a]].co=trasform2(obj,vertice)
	esce()

def allineafaccia():
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	v=me.verts.selected()
	vett1=Vector(msel[0][0],msel[0][1],msel[0][2])
	vett2=Vector(msel[1][0],msel[1][1],msel[1][2])
	vett3=Vector(msel[2][0],msel[2][1],msel[2][2])
	bb=TriangleNormal(vett1,vett2,vett3)
	for a in range (0,len(v)):
		v1=me.verts[v[a]]
		vett5=Vector(v1.co[0],v1.co[1],v1.co[2])
		aa=Intersect(vett1,vett2,vett3,bb,vett5,0)
		if togscegli.val>0:
			me.verts.extend(aa[0],aa[1],aa[2])
		elif togscegli.val==0:
			me.verts[v[a]].co[0],me.verts[v[a]].co[1],me.verts[v[a]].co[2]=aa[0],aa[1],aa[2]
	if togrem.val>0:
		for x in range(0,(len(me.verts))):
			me.verts[x].sel=1
		me.remDoubles(limita.val)
		for x in range(0,(len(me.verts))):
			me.verts[x].sel=0
	esce()
	
def allinealinea():
	entra()
	obj=Object.GetSelected()
	if obj!=[] and obj[0].getType()=="Mesh": obj=obj[0]
	else:PupMenu("Error%t|Mesh Object not selected");return
	me=obj.getData(mesh=1)
	v=me.verts.selected()
	ms0=trasform(obj,msel[0])
	ms1=trasform(obj,msel[1])
	distazimut(ms0[0],ms0[1],ms1[0],ms1[1])
	distanza,teta1=diaz[0],diaz[1]
	if teta1>= 0.0 and teta1<= 90.0:tetap=teta1+90.0
	if teta1>= 90.0 and teta1<= 360.0:tetap=teta1-90.0
	for a in range (0,len(v)):
		v1=me.verts[v[a]]
		vxyz=trasform(obj,v1.co)
		vx2=2.0*sin(radians(tetap))+vxyz[0]
		vy2=2.0*cos(radians(tetap))+vxyz[1]
		vz2=vxyz[2]
		p1=Vector(ms0[0],ms0[1],ms0[2])
		p2=Vector(ms1[0],ms1[1],ms1[2])
		p3=Vector(vxyz[0],vxyz[1],vxyz[2])
		p4=Vector(vx2,vy2,vz2)
		g=LineIntersect(p1,p2,p3,p4)
		if togscegli.val>0:
			me.verts.extend(g[0][0],g[0][1],g[0][2])
			me.edges.extend(me.verts[v[a]],me.verts[-1])
			me.verts[-1].co=trasform2(obj,me.verts[-1].co)
		elif togscegli.val==0:
			me.verts[v[a]].co[0],me.verts[v[a]].co[1],me.verts[v[a]].co[2]=g[0][0],g[0][1],g[0][2]
			me.verts[v[a]].co=trasform2(obj,me.verts[v[a]].co)
	if togrem.val>0:
		for x in range(0,(len(me.verts))):
			me.verts[x].sel=1
		me.remDoubles(limita.val)
		for x in range(0,(len(me.verts))):
			me.verts[x].sel=0
	esce()
	
#######################################
###### BLOCCHI MENU ###################
#######################################

def menu_cpa(testo):
	global blocco
	blocco=1
	tog3.val=memtog[0]
	tog4.val=memtog[1]
	D0=Create(rico[0])
	D12=Create(rico[12])
	D13=Create(rico[13])
	D14=Create(rico[14])
	D22=Create(rico[22])
	D23=Create(rico[23])
	DN1=Create(nrico[8])
	DN3=Create(nrico[2])
	DN4=Create(nrico[3])
	DN5=Create(nrico[4])
	DN6=Create(nrico[5])
	DN7=Create(nrico[6])
	DN2=Create(nrico[1])
	tog5=Create(0)
	pup_block= [\
	'MAIN DATA',\
	('Num of slices = ',D0,1,1000,'Number of subdivisions to be created'),\
	(testo,D12,0.0,1000.0,'Radius or Diameter'),\
	('Angle.initial =  ',D13,0.0,360.0,'Angle of the first vertex'),\
	('Angle.arc = ',D14,0.0,360.0,'Angle of arc to be created (0 to automatic calculation)'),\
	('Area = ',D22,0.0,10000.0,'given area'),\
	('Perimeter = ',D23,0.0,10000.0,'given perimeter'),\
	('Side polyg. = ',DN2,0.0,1000.0,'Side of the polygon to be created'),\
	'COMMANDS',\
	('Inscribe/Circumscr',tog3,'ON = Inscribed polygon    OFF = Circumscribed polygon'),\
	('Clockwise/Anti',tog4,'ON = Clockwise creation    OFF = Anticlockwise creation'),\
	'CORRECTIONS',\
	('Enable Correct.',tog5,'ON = Correction enable  OFF = Correction disable'),\
	('X correction = ',DN3,-1000.0,1000.0,'X correction for each vertex'),\
	('Y correction = ',DN4,-1000.0,1000.0,'Y correction for each vertex'),\
	('Z correction = ',DN1,-1000.0,1000.0,'Z correction for each vertex'),\
	('Radius correction = ',DN5,-1000.0,1000.0,'Radius correction for each vertex'),\
	'DATI EXTRA',\
	('Radius tip correction = ',DN6,-1000.0,1000.0,'Correction of the radius tip'),\
	('Frequency = ',DN7,0,1000,'Frequency of correction'),\
	]
	if not PupBlock('CIRCLES - POLYGONS - ARCS', pup_block):
		blocco=0
		return blocco
	rico[0]=D0.val
	rico[12]=D12.val
	rico[13]=D13.val
	rico[14]=D14.val
	rico[22]=D22.val
	rico[23]=D23.val
	memtog[0]=tog3.val
	memtog[1]=tog4.val
	nrico[1]=DN2.val
	nrico[8]=DN1.val
	nrico[0]=(DN1.val/D0.val)
	nrico[2]=DN3.val
	nrico[3]=DN4.val
	nrico[4]=DN5.val
	nrico[5]=DN6.val
	nrico[6]=DN7.val
	nr[0],nr[2],nr[3],nr[4],nr[5],nr[6]=nrico[0],nrico[2],nrico[3],nrico[4],nrico[5],nrico[6]
	if tog5.val<1:
		nr[0],nr[2],nr[3],nr[4],nr[5],nr[6]=0.0,0.0,0.0,0.0,0.0,1

def menu_ellissi(testo):
	global blocco
	blocco=1
	tog4.val=memtog[1]
	DN1=Create(nrico[12])
	D0=Create(rico[0])
	D13=Create(rico[13])
	D19=Create(rico[19])
	D20=Create(rico[20])
	D21=Create(rico[21])
	tog5=Create(0)
	pup_block= [\
	'MAIN DATA',\
	('Num of slices = ',D0,1,1000,'Number of subdivisions to be created'),\
	(testo+' X axis = ',D19,0.0,1000.0,'Radius or Diameter X axis'),\
	(testo+' Y axis = ',D20,0.0,1000.0,'Radius or Diameter Y axis'),\
	('Angle.initial =  ',D13,0.0,360.0,'Angle of the first vertex'),\
	('Angle.arc = ',D21,0.0,360.0,'Angle of arc to be created'),\
	'CORRECTIONS',\
	('Enable corrections',tog5,'ON = Enable  OFF = Disable'),\
	('Z correction = ',DN1,-1000.0,1000.0,'Z correction for each vertex'),\
	'COMANDI',\
	('Clockwise/Anti',tog4,'ON = Clockwise creation    OFF = Anticlockwise creation'),\
	]
	if not PupBlock('ELLIPSES - ARCS OF ELLIPSE', pup_block):
		blocco=0
		return blocco
	rico[0]=D0.val
	rico[19]=D19.val
	rico[13]=D13.val
	rico[20]=D20.val
	rico[21]=D21.val
	memtog[1]=tog4.val
	nrico[12]=DN1.val
	if tog5.val:
		nrico[13]=1

def menu_polare():
	global blocco
	blocco=1
	tog.val=memtog[2]
	D1=Create(memtog[4])
	D7=Create(rico[7])
	D8=Create(rico[8])
	D9=Create(rico[9])
	pup_block= [\
	'MAIN DATA',\
	('Length = ',D7,0.0,1000.0,'Length of the line'),\
	('Plane angle = ',D8,-360.0,360.0,'Angle on XY plane'),\
	('Elevation angle = ',D9,-90.0,90.0,'Angle of elevation'),\
	'COMMANDS',\
	('Length XY/3D',tog,'ON = Line length on XY plane   OFF = Line length in the 3D space'),\
	('Relative angle',D1,'ON = In function to a saved selected vertex  OFF = Absolute angle (NORTH)'),\
	]
	if not PupBlock('POLAR LINE', pup_block):
		blocco=0
		return blocco
	rico[7]=D7.val
	rico[8]=D8.val
	rico[9]=D9.val
	memtog[2]=tog.val
	memtog[4]=D1.val
	
def menu_parallela():
	global blocco
	blocco=1
	D1=Create(rico[1])
	DN8=Create(nrico[7])
	pup_block= [\
	'MAIN DATA',\
	('Distance = ',D1,0.0,1000.0,'Distance of the parallel to be created'),\
	'CORRECTIONS',\
	('Z correction = ',DN8,-1000.0,1000.0,'Z correction in function to the vertexes of the parallel'),\
	]
	if not PupBlock('PARALLEL LINE', pup_block):
		blocco=0
		return blocco
	rico[1]=D1.val
	nrico[7]=DN8.val
	
def menu_muro():
	global blocco
	blocco=1
	D1=Create(rico[1])
	D2=Create(memtog[3])
	pup_block= [\
	'MAIN DATA',\
	('Offset = ',D1,0,1000.0,'Offset to be created'),\
	'OPTIONS',\
	('Create faces',D2,'ON = Create faces     OFF = Just lines'),\
	]
	if not PupBlock('OFFSET', pup_block):
		blocco=0
		return blocco
	rico[1]=D1.val
	memtog[3]=D2.val

def menu_arrotondare():
	global blocco
	blocco=1
	D4=Create(rico[4])
	D5=Create(rico[5])
	pup_block= [\
	'MAIN DATA',\
	('Num of slices = ',D4,1,1000,'Number of subdivision to be created'),\
	('Radius = ',D5,0.0,1000.0,'Radius of rounded corner'),\
	]
	if not PupBlock('Round 2 lines', pup_block):
		blocco=0
		return blocco
	rico[4]=D4.val
	rico[5]=D5.val

def menu_vertice():
	global blocco
	blocco=1
	DN9=Create(nrico[9])
	DN10=Create(nrico[10])
	DN11=Create(nrico[11])
	pup_block= [\
	'MAIN DATA',\
	('X View = ',DN9,-1000.0,1000.0,'X coordinate'),\
	('Y View = ',DN10,-1000.0,1000.0,'Y coordinate'),\
	('Z View = ',DN11,-1000.0,1000.0,'Z coordinate'),\
	]
	if not PupBlock('NEW OBJ VERTEX', pup_block):
		blocco=0
		return blocco
	nrico[9]=DN9.val
	nrico[10]=DN10.val
	nrico[11]=DN11.val

def menu_muoviorto():
	global blocco
	blocco=1
	DN9=Create(nrico[14])
	DN10=Create(nrico[15])
	DN11=Create(nrico[16])
	pup_block= [\
	'MAIN DATA',\
	('X View = ',DN9,-1000.0,1000.0,'X coordinate'),\
	('Y View = ',DN10,-1000.0,1000.0,'Y coordinate'),\
	('Z View = ',DN11,-1000.0,1000.0,'Z coordinate'),\
	]
	if not PupBlock('MOVES ORTHOGONAL VIEW', pup_block):
		blocco=0
		return blocco
	nrico[14]=DN9.val
	nrico[15]=DN10.val
	nrico[16]=DN11.val

def menu_quote():
	global blocco
	blocco=1
	DN0=Create(riquote[0])
	DN1=Create(riquote[1])
	DN2=Create(riquote[2])
	DN3=Create(riquote[3])
	DN5=Create(riquote[5])
	DN6=Create(riquote[6])
	DN7=Create(riquote[7])
	DN8=Create(riquote[8])
	pup_block= [\
	'MAIN DATA',\
	('Distance    = ',DN1,0.0,1000.0,'Distance of quota lines from vertexes'),\
	('Line scale = ',DN2,0.001,1000.0,'Scale ratio of quota lines'),\
	('Text scale = ',DN0,0.001,1000.0,'Scale ratio of text'),\
	('Distance of text = ',DN3,-1000.0,1000.0,'Distance of text from line of quota (+/-)'),\
	('times for = ',DN6,-1000.0,1000.0,'Multiplier of value of linear quotas'),\
	('times degree = ',DN8,-1000.0,1000.0,'Multiplier of degree value'),\
	'',\
	'OPTIONS',\
	('Horizontal text',DN5,'ON = text always horizontal   OFF = text aligned'),\
	('Lines angles',DN7,'ON = Enables the construction of the lines of angular quotas'),\
	]
	if not PupBlock('SETTINGS QUOTAS', pup_block):
		blocco=0
		return blocco
	riquote[0]=DN0.val
	riquote[1]=DN1.val
	riquote[2]=DN2.val
	riquote[3]=DN3.val
	riquote[5]=DN5.val
	riquote[6]=DN6.val
	riquote[7]=DN7.val
	riquote[8]=DN8.val

def menu_scala():
	global blocco
	blocco=1
	DN17=Create(nrico[17])
	DN18=Create(nrico[18])
	DN19=Create(nrico[19])
	DN20=Create(nrico[20])
#	DN21=Create(nrico[21])
	pup_block= [\
	'MAIN DATA',\
	('X size= ',DN17,-1000.0,1000.0,'X size of the selection'),\
	('Y size= ',DN18,-1000.0,1000.0,'Y size of the selection'),\
	('Z size= ',DN19,-1000.0,1000.0,'Z size of the selection'),\
	'IN RESPECT OF',\
	('Object.Orig. / Vert.Sel.',DN20,'OFF = Size in function to the object origin   ON = To the selected and saved vertex with the S key'),\
#	'OGGETTI SELEZIONATI',\
#	('Muovi / Imita',DN21,'OFF = Muovi in relazione anche altri oggetti selezionati   ON = Imita le dimensioni su altri oggetti selezionati'),\
	]
	if not PupBlock('SIZE OF THE SELECTION', pup_block):
		blocco=0
		return blocco
	nrico[17]=DN17.val
	nrico[18]=DN18.val
	nrico[19]=DN19.val
	nrico[20]=DN20.val
#	nrico[21]=DN21.val

# Applica la matrice di trasformazione m al punto p
def trasforma(p, m):
	p = Vector(p)
	result = p*m
	return result	
				
# Calcola la distanza tra le proiezioni di due vettori sul piano xy
def distance2d(v1, v2):
	result = 0
	for i in range(0, 2):
		result += (v2[i] - v1[i])**2
	return math.sqrt(result)

def trasform(obj,xyz):
	# trasforma le coordinate oggetto in coordinate vista
	viewmatrix = Window.GetViewMatrix()
	objmatrix=obj.mat
	vertmatrix=objmatrix*viewmatrix
	cvettore=Vector(xyz)
	result = cvettore*vertmatrix
	return result
	
def trasform2(obj,xyz):
	# trasforma le coordinate vista in coordinate oggetto
	viewmatrix = Window.GetViewMatrix()
	xyz-=Vector(obj.loc)*viewmatrix
	objmatrix=obj.mat
	vertmatrix=objmatrix*viewmatrix
	cvettore=Vector(xyz)
	result = vertmatrix*cvettore
	return result

def cursoreinvista():
	# prende coordinate vista cursore
	viewMatrix=Window.GetViewMatrix()
	cursorPosition=Window.GetCursorPos()
	result = trasforma(cursorPosition,viewMatrix)
	return result
	
																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																		
